DELIMITER $$
CREATE OR REPLACE PROCEDURE `S_CLM_Event_Attribution`(IN vBatchSize BIGINT)
BEGIN
DECLARE Load_Exe_ID, Exe_ID,Load_Execution_ID int;
DECLARE Loop_Check_Var Int Default 0;
DECLARE V_Event_ID, V_Event_Execution_Date_ID,V_Event_Sent_Date_ID, V_Event_Response_Date_ID int ;
DECLARE V_Event_Execution_ID Varchar(20);
DECLARE vStart_Cnt BIGINT DEFAULT 0;
DECLARE vEnd_Cnt BIGINT;
DECLARE vStart_Cnt_Init BIGINT DEFAULT 0;
DECLARE vResponseDays int;
DECLARE vMax_Response_Window int default 8;
DECLARE Num_of_Attr INT DEFAULT 0;	
DECLARE V_Current_Execution_Date date default DATE_SUB(Current_Date(), INTERVAL 
(select ifnull(Value,1)  from CLM_Response_Config where Name='Response_LTD') DAY);
DECLARE V_Current_Execution_Date_Id int(11) default date_format(DATE_SUB(Current_Date(),INTERVAL 
(select ifnull(Value,11) from CLM_Response_Config where Name='Response_LTD') DAY),'%Y%m%d');


DECLARE V_Current_Execution_Date_Id_End int(11) default date_format(DATE_SUB(CURRENT_DATE(),
	INTERVAL (SELECT 
			ifnull(Value,10) 
		FROM
			CLM_Response_Config
		WHERE
			name = 'Response_FTD')  DAY) ,'%Y%m%d');
DECLARE curALL_EVENTS CURSOR For SELECT DISTINCT
    Event_ID,
    Event_Execution_Date_ID
FROM
    Event_Execution_History eeh
WHERE Customer_Id between vStart_Cnt and vEnd_Cnt
AND Event_Execution_Date_ID=V_Current_Execution_Date_Id
ORDER BY Created_Date DESC;


DECLARE CONTINUE HANDLER FOR NOT FOUND SET Loop_Check_Var=1;
DECLARE CONTINUE HANDLER FOR SQLWARNING
BEGIN
	GET DIAGNOSTICS CONDITION 1 @errsqlstate=RETURNED_SQLSTATE, @errno=MYSQL_ERRNO, @errtext = MESSAGE_TEXT;
	SET @logmsg=CONCAT(ifnull(@errsqlstate,'WARNING') , ifnull(@errno,'1'), ifnull(@errtext,'WARNING MESSAGE'));
    INSERT into ETL_Execution_Details (Procedure_Name, Job_Name, Start_Time, End_Time,`Status`, Load_Execution_ID) 
		values ('S_CLM_Event_Attribution', @logmsg ,now(),null,@errno, ifnull(Load_Exe_ID,1));
    SELECT 'S_CLM_Event_Attribution : Warning Message :' as '', @logmsg as '';
END;
DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 @sqlstate = RETURNED_SQLSTATE, @errno = MYSQL_ERRNO, @text = MESSAGE_TEXT;
	SET @vErrMsg = CONCAT(@errno, " (", @sqlstate, "): ", @text);
	INSERT into ETL_Execution_Details (Procedure_Name, Job_Name, Start_Time, End_Time,`Status`, Load_Execution_ID) 
			values ('S_CLM_Event_Attribution ', @vErrMsg ,now(),null,'ERROR', Load_Exe_ID);
	select now() as '', @vErrMsg as '' ;
END;
SET SQL_SAFE_UPDATES=0;
SET FOREIGN_KEY_CHECKS=0;

INSERT INTO Dashboard_Metrics_Log
(
`Screen_Name`,
`Status`
)
VALUES
('PERFORMANCE - DASHBOARD',
'Started');

CREATE OR REPLACE TABLE `Event_Execution_History_1DAY` (
  `Event_Execution_ID` char(50) NOT NULL,
  `Event_ID` int(11) NOT NULL,
  `Event_Execution_Date_ID` int(11) NOT NULL,
  `Customer_Id` bigint(20) NOT NULL,
  `Communication_Template_ID` int(11) DEFAULT NULL,
  `Communication_Channel` varchar(50) DEFAULT NULL,
  `In_Control_Group` char(1) DEFAULT NULL,
  `In_Event_Control_Group` varchar(1) DEFAULT NULL,
  `LT_Control_Covers_Response_Days` varchar(8) DEFAULT 'N',
  `ST_Control_Covers_Response_Days` varchar(8) DEFAULT 'N',
  `Segment_Id` bigint(20) DEFAULT -1,
  `Campaign_Segment_Id` int(10) DEFAULT -1,
  `Revenue_Center` varchar(256) DEFAULT '-1',
  `Delivery_Date` date DEFAULT NULL,
  `Delivery_Time` time DEFAULT NULL,
  `Delivery_DateTime` datetime,
  `Delivery_Status` char(1) DEFAULT NULL,
  `Open_Date` date DEFAULT NULL,
  `Open_Status` char(1) DEFAULT NULL,
  `CTA_Date` date DEFAULT NULL,
  `CTA_Status` char(1) DEFAULT NULL,
  PRIMARY KEY (`Customer_Id`,`Event_Execution_ID`),
  KEY `E_E_H_Event_Execution_Date_ID_idx` (`Event_Execution_Date_ID`),
  KEY `E_E_H_Event_ID_idx` (`Event_ID`),
  KEY `E_E_H_Communication_Template_ID_idx` (`Communication_Template_ID`),
  KEY `E_E_H_Customer_Id_CCH_idx` (`Customer_Id`),
  KEY `E_E_H_In_Control_Group_idx` (`In_Control_Group`),
  KEY `E_E_H_In_Event_Control_Group_idx` (`In_Event_Control_Group`),
  KEY `Segment_Id` (`Segment_Id`),
  KEY `Campaign_Segment_Id` (`Campaign_Segment_Id`),
  KEY `Revenue_Center` (`Revenue_Center`),
  KEY `Delivery_Date` (`Delivery_Date`),
  KEY `Delivery_DateTime` (`Delivery_DateTime`),
  KEY `LT_Control_Covers_Response_Days` (`LT_Control_Covers_Response_Days`),
  KEY `ST_Control_Covers_Response_Days` (`ST_Control_Covers_Response_Days`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8
 PARTITION BY RANGE (`Customer_Id`)
(PARTITION `p1` VALUES LESS THAN (100000) ENGINE = InnoDB,
 PARTITION `p2` VALUES LESS THAN (200000) ENGINE = InnoDB,
 PARTITION `p3` VALUES LESS THAN (300000) ENGINE = InnoDB,
 PARTITION `p4` VALUES LESS THAN (400000) ENGINE = InnoDB,
 PARTITION `p5` VALUES LESS THAN (500000) ENGINE = InnoDB,
 PARTITION `p6` VALUES LESS THAN (600000) ENGINE = InnoDB,
 PARTITION `p7` VALUES LESS THAN (700000) ENGINE = InnoDB,
 PARTITION `p8` VALUES LESS THAN (800000) ENGINE = InnoDB,
 PARTITION `p9` VALUES LESS THAN (900000) ENGINE = InnoDB,
 PARTITION `p10` VALUES LESS THAN (1000000) ENGINE = InnoDB,
 PARTITION `p11` VALUES LESS THAN (1100000) ENGINE = InnoDB,
 PARTITION `p12` VALUES LESS THAN (1200000) ENGINE = InnoDB,
 PARTITION `p13` VALUES LESS THAN (1300000) ENGINE = InnoDB,
 PARTITION `p14` VALUES LESS THAN (1400000) ENGINE = InnoDB,
 PARTITION `p15` VALUES LESS THAN (1500000) ENGINE = InnoDB,
 PARTITION `p16` VALUES LESS THAN (1600000) ENGINE = InnoDB,
 PARTITION `p17` VALUES LESS THAN (1700000) ENGINE = InnoDB,
 PARTITION `p18` VALUES LESS THAN (1800000) ENGINE = InnoDB,
 PARTITION `p19` VALUES LESS THAN (1900000) ENGINE = InnoDB,
 PARTITION `p20` VALUES LESS THAN (2000000) ENGINE = InnoDB,
 PARTITION `p21` VALUES LESS THAN (2100000) ENGINE = InnoDB,
 PARTITION `p22` VALUES LESS THAN (2200000) ENGINE = InnoDB,
 PARTITION `p23` VALUES LESS THAN (2300000) ENGINE = InnoDB,
 PARTITION `p24` VALUES LESS THAN (2400000) ENGINE = InnoDB,
 PARTITION `p25` VALUES LESS THAN (2500000) ENGINE = InnoDB,
 PARTITION `p26` VALUES LESS THAN (2600000) ENGINE = InnoDB,
 PARTITION `p27` VALUES LESS THAN (2700000) ENGINE = InnoDB,
 PARTITION `p28` VALUES LESS THAN (2800000) ENGINE = InnoDB,
 PARTITION `p29` VALUES LESS THAN (2900000) ENGINE = InnoDB,
 PARTITION `p30` VALUES LESS THAN (3000000) ENGINE = InnoDB,
 PARTITION `p31` VALUES LESS THAN (3100000) ENGINE = InnoDB,
 PARTITION `p32` VALUES LESS THAN (3200000) ENGINE = InnoDB,
 PARTITION `p33` VALUES LESS THAN (3300000) ENGINE = InnoDB,
 PARTITION `p34` VALUES LESS THAN (3400000) ENGINE = InnoDB,
 PARTITION `p35` VALUES LESS THAN (3500000) ENGINE = InnoDB,
 PARTITION `p36` VALUES LESS THAN (3600000) ENGINE = InnoDB,
 PARTITION `p37` VALUES LESS THAN (3700000) ENGINE = InnoDB,
 PARTITION `p38` VALUES LESS THAN (3800000) ENGINE = InnoDB,
 PARTITION `p39` VALUES LESS THAN (3900000) ENGINE = InnoDB,
 PARTITION `p40` VALUES LESS THAN (4000000) ENGINE = InnoDB,
 PARTITION `p41` VALUES LESS THAN (4100000) ENGINE = InnoDB,
 PARTITION `p42` VALUES LESS THAN (4200000) ENGINE = InnoDB,
 PARTITION `p43` VALUES LESS THAN (4300000) ENGINE = InnoDB,
 PARTITION `p44` VALUES LESS THAN (4400000) ENGINE = InnoDB,
 PARTITION `p45` VALUES LESS THAN (4500000) ENGINE = InnoDB,
 PARTITION `p46` VALUES LESS THAN (4600000) ENGINE = InnoDB,
 PARTITION `p47` VALUES LESS THAN (4700000) ENGINE = InnoDB,
 PARTITION `p48` VALUES LESS THAN (4800000) ENGINE = InnoDB,
 PARTITION `p49` VALUES LESS THAN (4900000) ENGINE = InnoDB,
 PARTITION `p50` VALUES LESS THAN (5000000) ENGINE = InnoDB,
 PARTITION `p51` VALUES LESS THAN (5100000) ENGINE = InnoDB,
 PARTITION `p52` VALUES LESS THAN (5200000) ENGINE = InnoDB,
 PARTITION `p53` VALUES LESS THAN (5300000) ENGINE = InnoDB,
 PARTITION `p54` VALUES LESS THAN (5400000) ENGINE = InnoDB,
 PARTITION `p55` VALUES LESS THAN (5500000) ENGINE = InnoDB,
 PARTITION `p56` VALUES LESS THAN (5600000) ENGINE = InnoDB,
 PARTITION `p57` VALUES LESS THAN (5700000) ENGINE = InnoDB,
 PARTITION `p58` VALUES LESS THAN (5800000) ENGINE = InnoDB,
 PARTITION `p59` VALUES LESS THAN (5900000) ENGINE = InnoDB,
 PARTITION `p60` VALUES LESS THAN (6000000) ENGINE = InnoDB,
 PARTITION `p61` VALUES LESS THAN (6100000) ENGINE = InnoDB,
 PARTITION `p62` VALUES LESS THAN (6200000) ENGINE = InnoDB,
 PARTITION `p63` VALUES LESS THAN (6300000) ENGINE = InnoDB,
 PARTITION `p64` VALUES LESS THAN (6400000) ENGINE = InnoDB,
 PARTITION `p65` VALUES LESS THAN (6500000) ENGINE = InnoDB,
 PARTITION `p66` VALUES LESS THAN (6600000) ENGINE = InnoDB,
 PARTITION `p67` VALUES LESS THAN (6700000) ENGINE = InnoDB,
 PARTITION `p68` VALUES LESS THAN (6800000) ENGINE = InnoDB,
 PARTITION `p69` VALUES LESS THAN (6900000) ENGINE = InnoDB,
 PARTITION `p70` VALUES LESS THAN (7000000) ENGINE = InnoDB,
 PARTITION `p71` VALUES LESS THAN (7100000) ENGINE = InnoDB,
 PARTITION `p72` VALUES LESS THAN (7200000) ENGINE = InnoDB,
 PARTITION `p73` VALUES LESS THAN (7300000) ENGINE = InnoDB,
 PARTITION `p74` VALUES LESS THAN (7400000) ENGINE = InnoDB,
 PARTITION `p75` VALUES LESS THAN (7500000) ENGINE = InnoDB,
 PARTITION `p76` VALUES LESS THAN (7600000) ENGINE = InnoDB,
 PARTITION `p77` VALUES LESS THAN (7700000) ENGINE = InnoDB,
 PARTITION `p78` VALUES LESS THAN (7800000) ENGINE = InnoDB,
 PARTITION `p79` VALUES LESS THAN (7900000) ENGINE = InnoDB,
 PARTITION `p80` VALUES LESS THAN (8000000) ENGINE = InnoDB,
 PARTITION `p81` VALUES LESS THAN (8100000) ENGINE = InnoDB,
 PARTITION `p82` VALUES LESS THAN (8200000) ENGINE = InnoDB,
 PARTITION `p83` VALUES LESS THAN (8300000) ENGINE = InnoDB,
 PARTITION `p84` VALUES LESS THAN (8400000) ENGINE = InnoDB,
 PARTITION `p85` VALUES LESS THAN (8500000) ENGINE = InnoDB,
 PARTITION `p86` VALUES LESS THAN (8600000) ENGINE = InnoDB,
 PARTITION `p87` VALUES LESS THAN (8700000) ENGINE = InnoDB,
 PARTITION `p88` VALUES LESS THAN (8800000) ENGINE = InnoDB,
 PARTITION `p89` VALUES LESS THAN (8900000) ENGINE = InnoDB,
 PARTITION `p90` VALUES LESS THAN (9000000) ENGINE = InnoDB,
 PARTITION `p91` VALUES LESS THAN (9100000) ENGINE = InnoDB,
 PARTITION `p92` VALUES LESS THAN (9200000) ENGINE = InnoDB,
 PARTITION `p93` VALUES LESS THAN (9300000) ENGINE = InnoDB,
 PARTITION `p94` VALUES LESS THAN (9400000) ENGINE = InnoDB,
 PARTITION `p95` VALUES LESS THAN (9500000) ENGINE = InnoDB,
 PARTITION `p96` VALUES LESS THAN (9600000) ENGINE = InnoDB,
 PARTITION `p97` VALUES LESS THAN (9700000) ENGINE = InnoDB,
 PARTITION `p98` VALUES LESS THAN (9800000) ENGINE = InnoDB,
 PARTITION `p99` VALUES LESS THAN (9900000) ENGINE = InnoDB,
 PARTITION `p100` VALUES LESS THAN (10000000) ENGINE = InnoDB,
 PARTITION `p101` VALUES LESS THAN (10100000) ENGINE = InnoDB,
 PARTITION `p102` VALUES LESS THAN (10200000) ENGINE = InnoDB,
 PARTITION `p103` VALUES LESS THAN (10300000) ENGINE = InnoDB,
 PARTITION `p104` VALUES LESS THAN (10400000) ENGINE = InnoDB,
 PARTITION `p105` VALUES LESS THAN (10500000) ENGINE = InnoDB,
 PARTITION `p106` VALUES LESS THAN (10600000) ENGINE = InnoDB,
 PARTITION `p107` VALUES LESS THAN (10700000) ENGINE = InnoDB,
 PARTITION `p108` VALUES LESS THAN (10800000) ENGINE = InnoDB,
 PARTITION `p109` VALUES LESS THAN (10900000) ENGINE = InnoDB,
 PARTITION `p110` VALUES LESS THAN (11000000) ENGINE = InnoDB,
 PARTITION `p111` VALUES LESS THAN (11100000) ENGINE = InnoDB,
 PARTITION `p112` VALUES LESS THAN (11200000) ENGINE = InnoDB,
 PARTITION `p113` VALUES LESS THAN (11300000) ENGINE = InnoDB,
 PARTITION `p114` VALUES LESS THAN (11400000) ENGINE = InnoDB,
 PARTITION `p115` VALUES LESS THAN (11500000) ENGINE = InnoDB,
 PARTITION `p116` VALUES LESS THAN (11600000) ENGINE = InnoDB,
 PARTITION `p117` VALUES LESS THAN (11700000) ENGINE = InnoDB,
 PARTITION `p118` VALUES LESS THAN (11800000) ENGINE = InnoDB,
 PARTITION `p119` VALUES LESS THAN (11900000) ENGINE = InnoDB,
 PARTITION `p120` VALUES LESS THAN (12000000) ENGINE = InnoDB,
 PARTITION `p121` VALUES LESS THAN (12100000) ENGINE = InnoDB,
 PARTITION `p122` VALUES LESS THAN (12200000) ENGINE = InnoDB,
 PARTITION `p123` VALUES LESS THAN (12300000) ENGINE = InnoDB,
 PARTITION `p124` VALUES LESS THAN (12400000) ENGINE = InnoDB,
 PARTITION `p125` VALUES LESS THAN (12500000) ENGINE = InnoDB,
 PARTITION `p126` VALUES LESS THAN (12600000) ENGINE = InnoDB,
 PARTITION `p127` VALUES LESS THAN (12700000) ENGINE = InnoDB,
 PARTITION `p128` VALUES LESS THAN (12800000) ENGINE = InnoDB,
 PARTITION `p129` VALUES LESS THAN (12900000) ENGINE = InnoDB,
 PARTITION `p130` VALUES LESS THAN (13000000) ENGINE = InnoDB,
 PARTITION `p131` VALUES LESS THAN (13100000) ENGINE = InnoDB,
 PARTITION `p132` VALUES LESS THAN (13200000) ENGINE = InnoDB,
 PARTITION `p133` VALUES LESS THAN (13300000) ENGINE = InnoDB,
 PARTITION `p134` VALUES LESS THAN (13400000) ENGINE = InnoDB,
 PARTITION `p135` VALUES LESS THAN (13500000) ENGINE = InnoDB,
 PARTITION `p136` VALUES LESS THAN (13600000) ENGINE = InnoDB,
 PARTITION `p137` VALUES LESS THAN (13700000) ENGINE = InnoDB,
 PARTITION `p138` VALUES LESS THAN (13800000) ENGINE = InnoDB,
 PARTITION `p139` VALUES LESS THAN (13900000) ENGINE = InnoDB,
 PARTITION `p140` VALUES LESS THAN (14000000) ENGINE = InnoDB,
 PARTITION `p141` VALUES LESS THAN (14100000) ENGINE = InnoDB,
 PARTITION `p142` VALUES LESS THAN (14200000) ENGINE = InnoDB,
 PARTITION `p143` VALUES LESS THAN (14300000) ENGINE = InnoDB,
 PARTITION `p144` VALUES LESS THAN (14400000) ENGINE = InnoDB,
 PARTITION `p145` VALUES LESS THAN (14500000) ENGINE = InnoDB,
 PARTITION `p146` VALUES LESS THAN (14600000) ENGINE = InnoDB,
 PARTITION `p147` VALUES LESS THAN (14700000) ENGINE = InnoDB,
 PARTITION `p148` VALUES LESS THAN (14800000) ENGINE = InnoDB,
 PARTITION `p149` VALUES LESS THAN (14900000) ENGINE = InnoDB,
 PARTITION `p150` VALUES LESS THAN (15000000) ENGINE = InnoDB,
 PARTITION `p151` VALUES LESS THAN (15100000) ENGINE = InnoDB,
 PARTITION `p152` VALUES LESS THAN (15200000) ENGINE = InnoDB,
 PARTITION `p153` VALUES LESS THAN (15300000) ENGINE = InnoDB,
 PARTITION `p154` VALUES LESS THAN (15400000) ENGINE = InnoDB,
 PARTITION `p155` VALUES LESS THAN (15500000) ENGINE = InnoDB,
 PARTITION `p156` VALUES LESS THAN (15600000) ENGINE = InnoDB,
 PARTITION `p157` VALUES LESS THAN (15700000) ENGINE = InnoDB,
 PARTITION `p158` VALUES LESS THAN (15800000) ENGINE = InnoDB,
 PARTITION `p159` VALUES LESS THAN (15900000) ENGINE = InnoDB,
 PARTITION `p160` VALUES LESS THAN (16000000) ENGINE = InnoDB,
 PARTITION `p161` VALUES LESS THAN (16100000) ENGINE = InnoDB,
 PARTITION `p162` VALUES LESS THAN (16200000) ENGINE = InnoDB,
 PARTITION `p163` VALUES LESS THAN (16300000) ENGINE = InnoDB,
 PARTITION `p164` VALUES LESS THAN (16400000) ENGINE = InnoDB,
 PARTITION `p165` VALUES LESS THAN (16500000) ENGINE = InnoDB,
 PARTITION `p166` VALUES LESS THAN (16600000) ENGINE = InnoDB,
 PARTITION `p167` VALUES LESS THAN (16700000) ENGINE = InnoDB,
 PARTITION `p168` VALUES LESS THAN (16800000) ENGINE = InnoDB,
 PARTITION `p169` VALUES LESS THAN (16900000) ENGINE = InnoDB,
 PARTITION `p170` VALUES LESS THAN (17000000) ENGINE = InnoDB,
 PARTITION `p171` VALUES LESS THAN (17100000) ENGINE = InnoDB,
 PARTITION `p172` VALUES LESS THAN (17200000) ENGINE = InnoDB,
 PARTITION `p173` VALUES LESS THAN (17300000) ENGINE = InnoDB,
 PARTITION `p174` VALUES LESS THAN (17400000) ENGINE = InnoDB,
 PARTITION `p175` VALUES LESS THAN (17500000) ENGINE = InnoDB,
 PARTITION `p176` VALUES LESS THAN (17600000) ENGINE = InnoDB,
 PARTITION `p177` VALUES LESS THAN (17700000) ENGINE = InnoDB,
 PARTITION `p178` VALUES LESS THAN (17800000) ENGINE = InnoDB,
 PARTITION `p179` VALUES LESS THAN (17900000) ENGINE = InnoDB,
 PARTITION `p180` VALUES LESS THAN (18000000) ENGINE = InnoDB,
 PARTITION `p181` VALUES LESS THAN (18100000) ENGINE = InnoDB,
 PARTITION `p182` VALUES LESS THAN (18200000) ENGINE = InnoDB,
 PARTITION `p183` VALUES LESS THAN (18300000) ENGINE = InnoDB,
 PARTITION `p184` VALUES LESS THAN (18400000) ENGINE = InnoDB,
 PARTITION `p185` VALUES LESS THAN (18500000) ENGINE = InnoDB,
 PARTITION `p186` VALUES LESS THAN (18600000) ENGINE = InnoDB,
 PARTITION `p187` VALUES LESS THAN (18700000) ENGINE = InnoDB,
 PARTITION `p188` VALUES LESS THAN (18800000) ENGINE = InnoDB,
 PARTITION `p189` VALUES LESS THAN (18900000) ENGINE = InnoDB,
 PARTITION `p190` VALUES LESS THAN (19000000) ENGINE = InnoDB,
 PARTITION `p191` VALUES LESS THAN (19100000) ENGINE = InnoDB,
 PARTITION `p192` VALUES LESS THAN (19200000) ENGINE = InnoDB,
 PARTITION `p193` VALUES LESS THAN (19300000) ENGINE = InnoDB,
 PARTITION `p194` VALUES LESS THAN (19400000) ENGINE = InnoDB,
 PARTITION `p195` VALUES LESS THAN (19500000) ENGINE = InnoDB,
 PARTITION `p196` VALUES LESS THAN (19600000) ENGINE = InnoDB,
 PARTITION `p197` VALUES LESS THAN (19700000) ENGINE = InnoDB,
 PARTITION `p198` VALUES LESS THAN (19800000) ENGINE = InnoDB,
 PARTITION `p199` VALUES LESS THAN (19900000) ENGINE = InnoDB,
 PARTITION `p200` VALUES LESS THAN (20000000) ENGINE = InnoDB,
 PARTITION `p201` VALUES LESS THAN (20100000) ENGINE = InnoDB,
 PARTITION `p202` VALUES LESS THAN (20200000) ENGINE = InnoDB,
 PARTITION `p203` VALUES LESS THAN (20300000) ENGINE = InnoDB,
 PARTITION `p204` VALUES LESS THAN (20400000) ENGINE = InnoDB,
 PARTITION `p205` VALUES LESS THAN (20500000) ENGINE = InnoDB,
 PARTITION `p206` VALUES LESS THAN (20600000) ENGINE = InnoDB,
 PARTITION `p207` VALUES LESS THAN (20700000) ENGINE = InnoDB,
 PARTITION `p208` VALUES LESS THAN (20800000) ENGINE = InnoDB,
 PARTITION `p209` VALUES LESS THAN (20900000) ENGINE = InnoDB,
 PARTITION `p210` VALUES LESS THAN (21000000) ENGINE = InnoDB,
 PARTITION `p211` VALUES LESS THAN (21100000) ENGINE = InnoDB,
 PARTITION `p212` VALUES LESS THAN (21200000) ENGINE = InnoDB,
 PARTITION `p213` VALUES LESS THAN (21300000) ENGINE = InnoDB,
 PARTITION `p214` VALUES LESS THAN (21400000) ENGINE = InnoDB,
 PARTITION `p215` VALUES LESS THAN (21500000) ENGINE = InnoDB,
 PARTITION `p216` VALUES LESS THAN (21600000) ENGINE = InnoDB,
 PARTITION `p217` VALUES LESS THAN (21700000) ENGINE = InnoDB,
 PARTITION `p218` VALUES LESS THAN (21800000) ENGINE = InnoDB,
 PARTITION `p219` VALUES LESS THAN (21900000) ENGINE = InnoDB,
 PARTITION `p220` VALUES LESS THAN (22000000) ENGINE = InnoDB,
 PARTITION `p221` VALUES LESS THAN (22100000) ENGINE = InnoDB,
 PARTITION `p222` VALUES LESS THAN (22200000) ENGINE = InnoDB,
 PARTITION `p223` VALUES LESS THAN (22300000) ENGINE = InnoDB,
 PARTITION `p224` VALUES LESS THAN (22400000) ENGINE = InnoDB,
 PARTITION `p225` VALUES LESS THAN (22500000) ENGINE = InnoDB,
 PARTITION `p226` VALUES LESS THAN (22600000) ENGINE = InnoDB,
 PARTITION `p227` VALUES LESS THAN (22700000) ENGINE = InnoDB,
 PARTITION `p228` VALUES LESS THAN (22800000) ENGINE = InnoDB,
 PARTITION `p229` VALUES LESS THAN (22900000) ENGINE = InnoDB,
 PARTITION `p230` VALUES LESS THAN (23000000) ENGINE = InnoDB,
 PARTITION `p231` VALUES LESS THAN (23100000) ENGINE = InnoDB,
 PARTITION `p232` VALUES LESS THAN (23200000) ENGINE = InnoDB,
 PARTITION `p233` VALUES LESS THAN (23300000) ENGINE = InnoDB,
 PARTITION `p234` VALUES LESS THAN (23400000) ENGINE = InnoDB,
 PARTITION `p235` VALUES LESS THAN (23500000) ENGINE = InnoDB,
 PARTITION `p236` VALUES LESS THAN (23600000) ENGINE = InnoDB,
 PARTITION `p237` VALUES LESS THAN (23700000) ENGINE = InnoDB,
 PARTITION `p238` VALUES LESS THAN (23800000) ENGINE = InnoDB,
 PARTITION `p239` VALUES LESS THAN (23900000) ENGINE = InnoDB,
 PARTITION `p240` VALUES LESS THAN (24000000) ENGINE = InnoDB,
 PARTITION `p241` VALUES LESS THAN (24100000) ENGINE = InnoDB,
 PARTITION `p242` VALUES LESS THAN (24200000) ENGINE = InnoDB,
 PARTITION `p243` VALUES LESS THAN (24300000) ENGINE = InnoDB,
 PARTITION `p244` VALUES LESS THAN (24400000) ENGINE = InnoDB,
 PARTITION `p245` VALUES LESS THAN (24500000) ENGINE = InnoDB,
 PARTITION `p246` VALUES LESS THAN (24600000) ENGINE = InnoDB,
 PARTITION `p247` VALUES LESS THAN (24700000) ENGINE = InnoDB,
 PARTITION `p248` VALUES LESS THAN (24800000) ENGINE = InnoDB,
 PARTITION `p249` VALUES LESS THAN (24900000) ENGINE = InnoDB,
 PARTITION `p250` VALUES LESS THAN (25000000) ENGINE = InnoDB,
 PARTITION `p251` VALUES LESS THAN (25100000) ENGINE = InnoDB,
 PARTITION `p252` VALUES LESS THAN (25200000) ENGINE = InnoDB,
 PARTITION `p253` VALUES LESS THAN (25300000) ENGINE = InnoDB,
 PARTITION `p254` VALUES LESS THAN (25400000) ENGINE = InnoDB,
 PARTITION `p255` VALUES LESS THAN (25500000) ENGINE = InnoDB,
 PARTITION `p256` VALUES LESS THAN (25600000) ENGINE = InnoDB,
 PARTITION `p257` VALUES LESS THAN (25700000) ENGINE = InnoDB,
 PARTITION `p258` VALUES LESS THAN (25800000) ENGINE = InnoDB,
 PARTITION `p259` VALUES LESS THAN (25900000) ENGINE = InnoDB,
 PARTITION `p260` VALUES LESS THAN (26000000) ENGINE = InnoDB,
 PARTITION `p261` VALUES LESS THAN (26100000) ENGINE = InnoDB,
 PARTITION `p262` VALUES LESS THAN (26200000) ENGINE = InnoDB,
 PARTITION `p263` VALUES LESS THAN (26300000) ENGINE = InnoDB,
 PARTITION `p264` VALUES LESS THAN (26400000) ENGINE = InnoDB,
 PARTITION `p265` VALUES LESS THAN (26500000) ENGINE = InnoDB,
 PARTITION `p266` VALUES LESS THAN (26600000) ENGINE = InnoDB,
 PARTITION `p267` VALUES LESS THAN (26700000) ENGINE = InnoDB,
 PARTITION `p268` VALUES LESS THAN (26800000) ENGINE = InnoDB,
 PARTITION `p269` VALUES LESS THAN (26900000) ENGINE = InnoDB,
 PARTITION `p270` VALUES LESS THAN (27000000) ENGINE = InnoDB,
 PARTITION `p271` VALUES LESS THAN (27100000) ENGINE = InnoDB,
 PARTITION `p272` VALUES LESS THAN (27200000) ENGINE = InnoDB,
 PARTITION `p273` VALUES LESS THAN (27300000) ENGINE = InnoDB,
 PARTITION `p274` VALUES LESS THAN (27400000) ENGINE = InnoDB,
 PARTITION `p275` VALUES LESS THAN (27500000) ENGINE = InnoDB,
 PARTITION `p276` VALUES LESS THAN (27600000) ENGINE = InnoDB,
 PARTITION `p277` VALUES LESS THAN (27700000) ENGINE = InnoDB,
 PARTITION `p278` VALUES LESS THAN (27800000) ENGINE = InnoDB,
 PARTITION `p279` VALUES LESS THAN (27900000) ENGINE = InnoDB,
 PARTITION `p280` VALUES LESS THAN (28000000) ENGINE = InnoDB,
 PARTITION `p281` VALUES LESS THAN (28100000) ENGINE = InnoDB,
 PARTITION `p282` VALUES LESS THAN (28200000) ENGINE = InnoDB,
 PARTITION `p283` VALUES LESS THAN (28300000) ENGINE = InnoDB,
 PARTITION `p284` VALUES LESS THAN (28400000) ENGINE = InnoDB,
 PARTITION `p285` VALUES LESS THAN (28500000) ENGINE = InnoDB,
 PARTITION `p286` VALUES LESS THAN (28600000) ENGINE = InnoDB,
 PARTITION `p287` VALUES LESS THAN (28700000) ENGINE = InnoDB,
 PARTITION `p288` VALUES LESS THAN (28800000) ENGINE = InnoDB,
 PARTITION `p289` VALUES LESS THAN (28900000) ENGINE = InnoDB,
 PARTITION `p290` VALUES LESS THAN (29000000) ENGINE = InnoDB,
 PARTITION `p291` VALUES LESS THAN (29100000) ENGINE = InnoDB,
 PARTITION `p292` VALUES LESS THAN (29200000) ENGINE = InnoDB,
 PARTITION `p293` VALUES LESS THAN (29300000) ENGINE = InnoDB,
 PARTITION `p294` VALUES LESS THAN (29400000) ENGINE = InnoDB,
 PARTITION `p295` VALUES LESS THAN (29500000) ENGINE = InnoDB,
 PARTITION `p296` VALUES LESS THAN (29600000) ENGINE = InnoDB,
 PARTITION `p297` VALUES LESS THAN (29700000) ENGINE = InnoDB,
 PARTITION `p298` VALUES LESS THAN (29800000) ENGINE = InnoDB,
 PARTITION `p299` VALUES LESS THAN (29900000) ENGINE = InnoDB,
 PARTITION `p300` VALUES LESS THAN (30000000) ENGINE = InnoDB,
 PARTITION `p301` VALUES LESS THAN (30100000) ENGINE = InnoDB,
 PARTITION `p302` VALUES LESS THAN (30200000) ENGINE = InnoDB,
 PARTITION `p303` VALUES LESS THAN (30300000) ENGINE = InnoDB,
 PARTITION `p304` VALUES LESS THAN (30400000) ENGINE = InnoDB,
 PARTITION `p305` VALUES LESS THAN (30500000) ENGINE = InnoDB,
 PARTITION `p306` VALUES LESS THAN (30600000) ENGINE = InnoDB,
 PARTITION `p307` VALUES LESS THAN (30700000) ENGINE = InnoDB,
 PARTITION `p308` VALUES LESS THAN (30800000) ENGINE = InnoDB,
 PARTITION `p309` VALUES LESS THAN (30900000) ENGINE = InnoDB,
 PARTITION `p310` VALUES LESS THAN (31000000) ENGINE = InnoDB,
 PARTITION `p311` VALUES LESS THAN (31100000) ENGINE = InnoDB,
 PARTITION `p312` VALUES LESS THAN (31200000) ENGINE = InnoDB,
 PARTITION `p313` VALUES LESS THAN (31300000) ENGINE = InnoDB,
 PARTITION `p314` VALUES LESS THAN (31400000) ENGINE = InnoDB,
 PARTITION `p315` VALUES LESS THAN (31500000) ENGINE = InnoDB,
 PARTITION `p316` VALUES LESS THAN (31600000) ENGINE = InnoDB,
 PARTITION `p317` VALUES LESS THAN (31700000) ENGINE = InnoDB,
 PARTITION `p318` VALUES LESS THAN (31800000) ENGINE = InnoDB,
 PARTITION `p319` VALUES LESS THAN (31900000) ENGINE = InnoDB,
 PARTITION `p320` VALUES LESS THAN (32000000) ENGINE = InnoDB,
 PARTITION `p321` VALUES LESS THAN (32100000) ENGINE = InnoDB,
 PARTITION `p322` VALUES LESS THAN (32200000) ENGINE = InnoDB,
 PARTITION `p323` VALUES LESS THAN (32300000) ENGINE = InnoDB,
 PARTITION `p324` VALUES LESS THAN (32400000) ENGINE = InnoDB,
 PARTITION `p325` VALUES LESS THAN (32500000) ENGINE = InnoDB,
 PARTITION `p326` VALUES LESS THAN (32600000) ENGINE = InnoDB,
 PARTITION `p327` VALUES LESS THAN (32700000) ENGINE = InnoDB,
 PARTITION `p328` VALUES LESS THAN (32800000) ENGINE = InnoDB,
 PARTITION `p329` VALUES LESS THAN (32900000) ENGINE = InnoDB,
 PARTITION `p330` VALUES LESS THAN (33000000) ENGINE = InnoDB,
 PARTITION `p331` VALUES LESS THAN (33100000) ENGINE = InnoDB,
 PARTITION `p332` VALUES LESS THAN (33200000) ENGINE = InnoDB,
 PARTITION `p333` VALUES LESS THAN (33300000) ENGINE = InnoDB,
 PARTITION `p334` VALUES LESS THAN (33400000) ENGINE = InnoDB,
 PARTITION `p335` VALUES LESS THAN (33500000) ENGINE = InnoDB,
 PARTITION `p336` VALUES LESS THAN (33600000) ENGINE = InnoDB,
 PARTITION `p337` VALUES LESS THAN (33700000) ENGINE = InnoDB,
 PARTITION `p338` VALUES LESS THAN (33800000) ENGINE = InnoDB,
 PARTITION `p339` VALUES LESS THAN (33900000) ENGINE = InnoDB,
 PARTITION `p340` VALUES LESS THAN (34000000) ENGINE = InnoDB,
 PARTITION `p341` VALUES LESS THAN (34100000) ENGINE = InnoDB,
 PARTITION `p342` VALUES LESS THAN (34200000) ENGINE = InnoDB,
 PARTITION `p343` VALUES LESS THAN (34300000) ENGINE = InnoDB,
 PARTITION `p344` VALUES LESS THAN (34400000) ENGINE = InnoDB,
 PARTITION `p345` VALUES LESS THAN (34500000) ENGINE = InnoDB,
 PARTITION `p346` VALUES LESS THAN (34600000) ENGINE = InnoDB,
 PARTITION `p347` VALUES LESS THAN (34700000) ENGINE = InnoDB,
 PARTITION `p348` VALUES LESS THAN (34800000) ENGINE = InnoDB,
 PARTITION `p349` VALUES LESS THAN (34900000) ENGINE = InnoDB,
 PARTITION `p350` VALUES LESS THAN (35000000) ENGINE = InnoDB,
 PARTITION `p351` VALUES LESS THAN (35100000) ENGINE = InnoDB,
 PARTITION `p352` VALUES LESS THAN (35200000) ENGINE = InnoDB,
 PARTITION `p353` VALUES LESS THAN (35300000) ENGINE = InnoDB,
 PARTITION `p354` VALUES LESS THAN (35400000) ENGINE = InnoDB,
 PARTITION `p355` VALUES LESS THAN (35500000) ENGINE = InnoDB,
 PARTITION `p356` VALUES LESS THAN (35600000) ENGINE = InnoDB,
 PARTITION `p357` VALUES LESS THAN (35700000) ENGINE = InnoDB,
 PARTITION `p358` VALUES LESS THAN (35800000) ENGINE = InnoDB,
 PARTITION `p359` VALUES LESS THAN (35900000) ENGINE = InnoDB,
 PARTITION `p360` VALUES LESS THAN (36000000) ENGINE = InnoDB,
 PARTITION `p361` VALUES LESS THAN (36100000) ENGINE = InnoDB,
 PARTITION `p362` VALUES LESS THAN (36200000) ENGINE = InnoDB,
 PARTITION `p363` VALUES LESS THAN (36300000) ENGINE = InnoDB,
 PARTITION `p364` VALUES LESS THAN (36400000) ENGINE = InnoDB,
 PARTITION `p365` VALUES LESS THAN (36500000) ENGINE = InnoDB,
 PARTITION `p366` VALUES LESS THAN (36600000) ENGINE = InnoDB,
 PARTITION `p367` VALUES LESS THAN (36700000) ENGINE = InnoDB,
 PARTITION `p368` VALUES LESS THAN (36800000) ENGINE = InnoDB,
 PARTITION `p369` VALUES LESS THAN (36900000) ENGINE = InnoDB,
 PARTITION `p370` VALUES LESS THAN (37000000) ENGINE = InnoDB,
 PARTITION `p371` VALUES LESS THAN (37100000) ENGINE = InnoDB,
 PARTITION `p372` VALUES LESS THAN (37200000) ENGINE = InnoDB,
 PARTITION `p373` VALUES LESS THAN (37300000) ENGINE = InnoDB,
 PARTITION `p374` VALUES LESS THAN (37400000) ENGINE = InnoDB,
 PARTITION `p375` VALUES LESS THAN (37500000) ENGINE = InnoDB,
 PARTITION `p376` VALUES LESS THAN (37600000) ENGINE = InnoDB,
 PARTITION `p377` VALUES LESS THAN (37700000) ENGINE = InnoDB,
 PARTITION `p378` VALUES LESS THAN (37800000) ENGINE = InnoDB,
 PARTITION `p379` VALUES LESS THAN (37900000) ENGINE = InnoDB,
 PARTITION `p380` VALUES LESS THAN (38000000) ENGINE = InnoDB,
 PARTITION `p381` VALUES LESS THAN (38100000) ENGINE = InnoDB,
 PARTITION `p382` VALUES LESS THAN (38200000) ENGINE = InnoDB,
 PARTITION `p383` VALUES LESS THAN (38300000) ENGINE = InnoDB,
 PARTITION `p384` VALUES LESS THAN (38400000) ENGINE = InnoDB,
 PARTITION `p385` VALUES LESS THAN (38500000) ENGINE = InnoDB,
 PARTITION `p386` VALUES LESS THAN (38600000) ENGINE = InnoDB,
 PARTITION `p387` VALUES LESS THAN (38700000) ENGINE = InnoDB,
 PARTITION `p388` VALUES LESS THAN (38800000) ENGINE = InnoDB,
 PARTITION `p389` VALUES LESS THAN (38900000) ENGINE = InnoDB,
 PARTITION `p390` VALUES LESS THAN (39000000) ENGINE = InnoDB,
 PARTITION `p391` VALUES LESS THAN (39100000) ENGINE = InnoDB,
 PARTITION `p392` VALUES LESS THAN (39200000) ENGINE = InnoDB,
 PARTITION `p393` VALUES LESS THAN (39300000) ENGINE = InnoDB,
 PARTITION `p394` VALUES LESS THAN (39400000) ENGINE = InnoDB,
 PARTITION `p395` VALUES LESS THAN (39500000) ENGINE = InnoDB,
 PARTITION `p396` VALUES LESS THAN (39600000) ENGINE = InnoDB,
 PARTITION `p397` VALUES LESS THAN (39700000) ENGINE = InnoDB,
 PARTITION `p398` VALUES LESS THAN (39800000) ENGINE = InnoDB,
 PARTITION `p399` VALUES LESS THAN (39900000) ENGINE = InnoDB,
 PARTITION `p400` VALUES LESS THAN (40000000) ENGINE = InnoDB,
 PARTITION `p401` VALUES LESS THAN (40100000) ENGINE = InnoDB,
 PARTITION `p402` VALUES LESS THAN (40200000) ENGINE = InnoDB,
 PARTITION `p403` VALUES LESS THAN (40300000) ENGINE = InnoDB,
 PARTITION `p404` VALUES LESS THAN (40400000) ENGINE = InnoDB,
 PARTITION `p405` VALUES LESS THAN (40500000) ENGINE = InnoDB,
 PARTITION `p406` VALUES LESS THAN (40600000) ENGINE = InnoDB,
 PARTITION `p407` VALUES LESS THAN (40700000) ENGINE = InnoDB,
 PARTITION `p408` VALUES LESS THAN (40800000) ENGINE = InnoDB,
 PARTITION `p409` VALUES LESS THAN (40900000) ENGINE = InnoDB,
 PARTITION `p410` VALUES LESS THAN (41000000) ENGINE = InnoDB,
 PARTITION `p411` VALUES LESS THAN (41100000) ENGINE = InnoDB,
 PARTITION `p412` VALUES LESS THAN (41200000) ENGINE = InnoDB,
 PARTITION `p413` VALUES LESS THAN (41300000) ENGINE = InnoDB,
 PARTITION `p414` VALUES LESS THAN (41400000) ENGINE = InnoDB,
 PARTITION `p415` VALUES LESS THAN (41500000) ENGINE = InnoDB,
 PARTITION `p416` VALUES LESS THAN (41600000) ENGINE = InnoDB,
 PARTITION `p417` VALUES LESS THAN (41700000) ENGINE = InnoDB,
 PARTITION `p418` VALUES LESS THAN (41800000) ENGINE = InnoDB,
 PARTITION `p419` VALUES LESS THAN (41900000) ENGINE = InnoDB,
 PARTITION `p420` VALUES LESS THAN (42000000) ENGINE = InnoDB,
 PARTITION `p421` VALUES LESS THAN (42100000) ENGINE = InnoDB,
 PARTITION `p422` VALUES LESS THAN (42200000) ENGINE = InnoDB,
 PARTITION `p423` VALUES LESS THAN (42300000) ENGINE = InnoDB,
 PARTITION `p424` VALUES LESS THAN (42400000) ENGINE = InnoDB,
 PARTITION `p425` VALUES LESS THAN (42500000) ENGINE = InnoDB,
 PARTITION `p426` VALUES LESS THAN (42600000) ENGINE = InnoDB,
 PARTITION `p427` VALUES LESS THAN (42700000) ENGINE = InnoDB,
 PARTITION `p428` VALUES LESS THAN (42800000) ENGINE = InnoDB,
 PARTITION `p429` VALUES LESS THAN (42900000) ENGINE = InnoDB,
 PARTITION `p430` VALUES LESS THAN (43000000) ENGINE = InnoDB,
 PARTITION `p431` VALUES LESS THAN (43100000) ENGINE = InnoDB,
 PARTITION `p432` VALUES LESS THAN (43200000) ENGINE = InnoDB,
 PARTITION `p433` VALUES LESS THAN (43300000) ENGINE = InnoDB,
 PARTITION `p434` VALUES LESS THAN (43400000) ENGINE = InnoDB,
 PARTITION `p435` VALUES LESS THAN (43500000) ENGINE = InnoDB,
 PARTITION `p436` VALUES LESS THAN (43600000) ENGINE = InnoDB,
 PARTITION `p437` VALUES LESS THAN (43700000) ENGINE = InnoDB,
 PARTITION `p438` VALUES LESS THAN (43800000) ENGINE = InnoDB,
 PARTITION `p439` VALUES LESS THAN (43900000) ENGINE = InnoDB,
 PARTITION `p440` VALUES LESS THAN (44000000) ENGINE = InnoDB,
 PARTITION `p441` VALUES LESS THAN (44100000) ENGINE = InnoDB,
 PARTITION `p442` VALUES LESS THAN (44200000) ENGINE = InnoDB,
 PARTITION `p443` VALUES LESS THAN (44300000) ENGINE = InnoDB,
 PARTITION `p444` VALUES LESS THAN (44400000) ENGINE = InnoDB,
 PARTITION `p445` VALUES LESS THAN (44500000) ENGINE = InnoDB,
 PARTITION `p446` VALUES LESS THAN (44600000) ENGINE = InnoDB,
 PARTITION `p447` VALUES LESS THAN (44700000) ENGINE = InnoDB,
 PARTITION `p448` VALUES LESS THAN (44800000) ENGINE = InnoDB,
 PARTITION `p449` VALUES LESS THAN (44900000) ENGINE = InnoDB,
 PARTITION `p450` VALUES LESS THAN (45000000) ENGINE = InnoDB,
 PARTITION `p451` VALUES LESS THAN (45100000) ENGINE = InnoDB,
 PARTITION `p452` VALUES LESS THAN (45200000) ENGINE = InnoDB,
 PARTITION `p453` VALUES LESS THAN (45300000) ENGINE = InnoDB,
 PARTITION `p454` VALUES LESS THAN (45400000) ENGINE = InnoDB,
 PARTITION `p455` VALUES LESS THAN (45500000) ENGINE = InnoDB,
 PARTITION `p456` VALUES LESS THAN (45600000) ENGINE = InnoDB,
 PARTITION `p457` VALUES LESS THAN (45700000) ENGINE = InnoDB,
 PARTITION `p458` VALUES LESS THAN (45800000) ENGINE = InnoDB,
 PARTITION `p459` VALUES LESS THAN (45900000) ENGINE = InnoDB,
 PARTITION `p460` VALUES LESS THAN (46000000) ENGINE = InnoDB,
 PARTITION `p461` VALUES LESS THAN (46100000) ENGINE = InnoDB,
 PARTITION `p462` VALUES LESS THAN (46200000) ENGINE = InnoDB,
 PARTITION `p463` VALUES LESS THAN (46300000) ENGINE = InnoDB,
 PARTITION `p464` VALUES LESS THAN (46400000) ENGINE = InnoDB,
 PARTITION `p465` VALUES LESS THAN (46500000) ENGINE = InnoDB,
 PARTITION `p466` VALUES LESS THAN (46600000) ENGINE = InnoDB,
 PARTITION `p467` VALUES LESS THAN (46700000) ENGINE = InnoDB,
 PARTITION `p468` VALUES LESS THAN (46800000) ENGINE = InnoDB,
 PARTITION `p469` VALUES LESS THAN (46900000) ENGINE = InnoDB,
 PARTITION `p470` VALUES LESS THAN (47000000) ENGINE = InnoDB,
 PARTITION `p471` VALUES LESS THAN (47100000) ENGINE = InnoDB,
 PARTITION `p472` VALUES LESS THAN (47200000) ENGINE = InnoDB,
 PARTITION `p473` VALUES LESS THAN (47300000) ENGINE = InnoDB,
 PARTITION `p474` VALUES LESS THAN (47400000) ENGINE = InnoDB,
 PARTITION `p475` VALUES LESS THAN (47500000) ENGINE = InnoDB,
 PARTITION `p476` VALUES LESS THAN (47600000) ENGINE = InnoDB,
 PARTITION `p477` VALUES LESS THAN (47700000) ENGINE = InnoDB,
 PARTITION `p478` VALUES LESS THAN (47800000) ENGINE = InnoDB,
 PARTITION `p479` VALUES LESS THAN (47900000) ENGINE = InnoDB,
 PARTITION `p480` VALUES LESS THAN (48000000) ENGINE = InnoDB,
 PARTITION `p481` VALUES LESS THAN (48100000) ENGINE = InnoDB,
 PARTITION `p482` VALUES LESS THAN (48200000) ENGINE = InnoDB,
 PARTITION `p483` VALUES LESS THAN (48300000) ENGINE = InnoDB,
 PARTITION `p484` VALUES LESS THAN (48400000) ENGINE = InnoDB,
 PARTITION `p485` VALUES LESS THAN (48500000) ENGINE = InnoDB,
 PARTITION `p486` VALUES LESS THAN (48600000) ENGINE = InnoDB,
 PARTITION `p487` VALUES LESS THAN (48700000) ENGINE = InnoDB,
 PARTITION `p488` VALUES LESS THAN (48800000) ENGINE = InnoDB,
 PARTITION `p489` VALUES LESS THAN (48900000) ENGINE = InnoDB,
 PARTITION `p490` VALUES LESS THAN (49000000) ENGINE = InnoDB,
 PARTITION `p491` VALUES LESS THAN (49100000) ENGINE = InnoDB,
 PARTITION `p492` VALUES LESS THAN (49200000) ENGINE = InnoDB,
 PARTITION `p493` VALUES LESS THAN (49300000) ENGINE = InnoDB,
 PARTITION `p494` VALUES LESS THAN (49400000) ENGINE = InnoDB,
 PARTITION `p495` VALUES LESS THAN (49500000) ENGINE = InnoDB,
 PARTITION `p496` VALUES LESS THAN (49600000) ENGINE = InnoDB,
 PARTITION `p497` VALUES LESS THAN (49700000) ENGINE = InnoDB,
 PARTITION `p498` VALUES LESS THAN (49800000) ENGINE = InnoDB,
 PARTITION `p499` VALUES LESS THAN (49900000) ENGINE = InnoDB,
 PARTITION `p500` VALUES LESS THAN (50000000) ENGINE = InnoDB,
 PARTITION `p501` VALUES LESS THAN MAXVALUE ENGINE = InnoDB);
 
SET Load_Exe_ID = F_Get_Load_Execution_Id();
SET Exe_ID = F_Get_Execution_Id();
SET Load_Execution_ID = 1;
INSERT into ETL_Execution_Details (Procedure_Name, Job_Name, Start_Time, End_Time,`Status`, Load_Execution_ID) 
		values ('S_CLM_Event_Attribution ', ' ' ,now(),null,'Started', Load_Exe_ID);
SELECT 'S_CLM_Event_Attribution : STARTED ' as '', NOW() as '' ;

select ifnull(Value,10) into vResponseDays from CLM_Response_Config where Name='Response_FTD'; 

select `Value` into @Hours_as_Resp from CLM_Response_Config where `Name` = 'Use_Hours_As_Response_Window';

IF @Hours_as_Resp = 'Y'
THEN
	set vMax_Response_Window=(select(SELECT ceil(max(Event_Response_Days)/24) FROM Event_Master) + 
		(select ifnull(Value,1) from CLM_Response_Config where Name='Campaign_Execution_Delay'));
ELSE
	set vMax_Response_Window=(select(SELECT max(Event_Response_Days) FROM Event_Master) + 
		(select ifnull(Value,1) from CLM_Response_Config where Name='Campaign_Execution_Delay'));
END IF;

SELECT Customer_Id INTO vStart_Cnt_Init FROM CDM_Bill_Details ORDER BY Customer_Id ASC LIMIT 1;
SELECT Customer_Id INTO @Rec_Cnt FROM CDM_Bill_Details ORDER BY Customer_Id DESC LIMIT 1;


LOOP_ALL_DATES: LOOP
	IF V_Current_Execution_Date_Id<V_Current_Execution_Date_Id_End
	THEN
		LEAVE LOOP_ALL_DATES;
	END IF;
	SET vStart_Cnt=0;
	
	SELECT 'S_CLM_Event_Attribution :Attribute ' as '', V_Current_Execution_Date_Id as '', V_Current_Execution_Date as '' ,NOW() as '' ; 
	INSERT into ETL_Execution_Details (Procedure_Name, Job_Name, Start_Time, End_Time,`Status`, Load_Execution_ID) 
		values ('S_CLM_Event_Attribution ', V_Current_Execution_Date_Id,now(),null,'Attribute', Load_Exe_ID);
	
	TRUNCATE Event_Execution_History_1DAY;
    
	
	LOOP_ALL_CUSTOMERS: LOOP
	    select count(1) into @NO_Campaigns from Event_Execution_History where Event_Execution_Date_ID=V_Current_Execution_Date_Id;
		IF @NO_Campaigns=0
	    THEN 
			     LEAVE LOOP_ALL_CUSTOMERS;
		END IF;
		SET vEnd_Cnt = vStart_Cnt + vBatchSize-1;
		
		SELECT 'S_CLM_Event_Attribution :' as '', concat(V_Current_Execution_Date_Id,'_',vEnd_Cnt) as '', NOW() as '' ; 
		INSERT into ETL_Execution_Details (Procedure_Name, Job_Name, Start_Time, End_Time,`Status`, Load_Execution_ID) 
			values ('S_CLM_Event_Attribution ', concat(V_Current_Execution_Date_Id,'_',vEnd_Cnt),now(),null,'Customer', Load_Exe_ID);
			
		SELECT `Value` into @Excluded_Stores from CLM_Response_Config where `Name` = 'Excluded_Store_Ids';
        if @Excluded_Stores is NULL or @Excluded_Stores = -1 or @Excluded_Stores = '' 
        THEN
			SET @Store_Exclusion_Condition = ' 1 = 1 ';
		ELSE 
			SET @Store_Exclusion_Condition = concat(' Store_Id not in (',@Excluded_Stores,') ');
		END IF;
        
        SELECT @Store_Exclusion_Condition;
		
		TRUNCATE CDM_Bill_Details_ResponseWindow;
        
		SET @SQL1=CONCAT('INSERT IGNORE into CDM_Bill_Details_ResponseWindow (  
		Customer_Id,
		Bill_Details_Id,
		Bill_Header_Id,
		Bill_Date,
        Bill_Time,
		Product_Id,
		Sale_Net_Val,
		Sale_Disc_Val,
		Sale_Qty) 
		SELECT 
		Customer_Id,
		Bill_Details_Id,
		Bill_Header_Id,
		Bill_Date,
        Bill_Time,
		Product_Id,
		Sale_Net_Val,
		Sale_Disc_Val,
		Sale_Qty
		FROM
			CDM_Bill_Details bills
		WHERE
		bills.Customer_Id BETWEEN ',vStart_Cnt,' AND ',vEnd_Cnt,'
		AND bills.Bill_Date BETWEEN "',V_Current_Execution_Date,'" AND DATE_ADD("',V_Current_Execution_Date,'", INTERVAL ',vMax_Response_Window,' DAY)
        AND ',@Store_Exclusion_Condition,'');
        SELECT @SQL1;
        
        prepare stmt from @SQL1;
		execute stmt;
		deallocate prepare stmt;
		
        UPDATE CDM_Bill_Details_ResponseWindow
        SET Bill_DateTime = CAST(CONCAT(Bill_Date,' ',ifnull(Bill_Time,(select `Value` from CLM_Response_Config where `Name` = 'Default_Order_Time'))) AS datetime);
        
		INSERT IGNORE INTO `Event_Execution_History_1DAY`
		(`Event_Execution_ID`,
		`Event_ID`,
		`Event_Execution_Date_ID`,
		`Customer_Id`,
		`Communication_Template_ID`,
		`Communication_Channel`,
		`In_Control_Group`,
		`In_Event_Control_Group`,
		`Segment_Id`,
		`Revenue_Center`,
        `LT_Control_Covers_Response_Days`,
        `ST_Control_Covers_Response_Days`)
		SELECT 
		`Event_Execution_ID`,
		`Event_ID`,
		`Event_Execution_Date_ID`,
		`Customer_Id`,
		`Communication_Template_ID`,
		`Communication_Channel`,
		`In_Control_Group`,
		`In_Event_Control_Group`,
		`Segment_Id`,
		`Revenue_Center`,
        `LT_Control_Covers_Response_Days`,
        `ST_Control_Covers_Response_Days`
		FROM Event_Execution_History where Customer_Id between vStart_Cnt and vEnd_Cnt 
		AND Event_Execution_Date_ID=V_Current_Execution_Date_Id;
        
        select ChannelName into @ChannelName from Event_Master where ID = V_Event_ID;
            IF @ChannelName = 'SMS'
            THEN
				select `Value` into @default_delivery_time from CLM_Response_Config where `Name` = 'Delivery_Time_SMS';
			ELSEIF @ChannelName = 'EMAIL'
            THEN
				select `Value` into @default_delivery_time from CLM_Response_Config where `Name` = 'Delivery_Time_EMAIL';
			ELSEIF @ChannelName = 'PN'
            THEN
				select `Value` into @default_delivery_time from CLM_Response_Config where `Name` = 'Delivery_Time_PN';
			ELSEIF @ChannelName = 'WHATSAPP'
            THEN
				select `Value` into @default_delivery_time from CLM_Response_Config where `Name` = 'Delivery_Time_WHATSAPP';
			ELSE
				select `Value` into @default_delivery_time from CLM_Response_Config where `Name` = 'Delivery_Time_SMS';
			END IF ;
        
        set @sql00=
		concat("UPDATE Event_Execution_History_1DAY eeh, CDM_Delivery_Report dr
		SET 
         eeh.Delivery_Status=dr.Delivery_Status,
		 eeh.Delivery_Date=dr.Delivery_Date,
         eeh.Delivery_Time=ifnull(dr.Delivery_Time,'",@default_delivery_time,"'),
         eeh.Delivery_Datetime=CAST(concat(dr.Delivery_Date,' ',ifnull(dr.Delivery_Time,'",@default_delivery_time,"')) AS datetime),
		 eeh.Open_Status=dr.Open_Status,
		 eeh.Open_Date=dr.Open_Date
		WHERE  eeh.Customer_Id between ",vStart_Cnt," and ",vEnd_Cnt," 
        AND eeh.Customer_Id=dr.Customer_Id
		AND eeh.Event_Execution_ID=dr.Event_Execution_ID"); 
        
			select @sql00;
            prepare stmt from @sql00;
			execute stmt;
			deallocate prepare stmt;
            
		set @sql01=
		concat("UPDATE Event_Execution_History_1DAY eeh, CDM_Click_Report dr
		SET 
		 eeh.CTA_Status='Y'
		WHERE  eeh.Customer_Id between ",vStart_Cnt," and ",vEnd_Cnt," 
        AND eeh.Customer_Id=dr.Customer_Id
		AND eeh.Event_Execution_ID=dr.Event_Execution_ID"); 
        
			select @sql01;
            prepare stmt from @sql01;
			execute stmt;
			deallocate prepare stmt;

		
		DELETE FROM Event_Attribution_History 
		WHERE Event_Execution_Date_ID = V_Current_Execution_Date_ID
		AND Customer_Id BETWEEN vStart_Cnt AND vEnd_Cnt;
        IF (SELECT `Value` from CLM_Response_Config where `Name` = "Consider_No_Delivery_Report_As_Undelivered") = "Y"
        THEN
        SET @Delivery_Check_Query = " ((campaigns.Delivery_Status = 'Y' and campaigns.In_Control_Group is null and campaigns.In_Event_Control_Group is null) or (campaigns.Delivery_Status is null and campaigns.In_Control_Group = 'Y' ) or (campaigns.Delivery_Status is null and campaigns.In_Event_Control_Group = 'Y' ))";
        ELSE 
        SET @Delivery_Check_Query = " (campaigns.Delivery_Status is null or campaigns.Delivery_Status <> 'N') ";
        END IF;
        SELECT @Delivery_Check_Query;
		SET Loop_Check_Var=0;
		OPEN curALL_EVENTS;
		LOOP_ALL_EVENTS : Loop
			FETCH curALL_EVENTS into V_Event_ID,V_Event_Execution_Date_ID;
			IF Loop_Check_Var THEN    
				LEAVE LOOP_ALL_EVENTS;
			END IF;
            
            SET @CamExecDely = (select ifnull(Value,1) from CLM_Response_Config where Name='Campaign_Execution_Delay');
            
            IF @Hours_as_Resp = 'Y'
			THEN
				SET @sql2= concat("INSERT IGNORE into Event_Attribution_History (
					`Customer_Id` ,
					`Bill_Details_ID` ,
					`Bill_Header_ID` ,
					`Bill_Date` ,
					`Product_Id`,
					`Sale_Net_Val`,
					`Sale_Disc_Val`,
					`Sale_Qty`,
					`Event_Execution_ID` ,
					`Event_ID` ,
					`Event_Execution_Date_ID`,
					`In_Control_Group`,
					`In_Event_Control_Group`
					 )
					SELECT 
					bills.`Customer_Id` ,
					bills.`Bill_Details_ID` ,
					bills.`Bill_Header_ID` ,
					bills.`Bill_Date`,
					bills.`Product_Id`,
					bills.`Sale_Net_Val`,
					bills.`Sale_Disc_Val`,
					bills.`Sale_Qty`,
					campaigns.`Event_Execution_ID` ,
					campaigns.`Event_ID` ,
					campaigns.`Event_Execution_Date_ID`,
					campaigns.`In_Control_Group`,
					campaigns.`In_Event_Control_Group`
				FROM Event_Execution_History_1DAY campaigns, CDM_Bill_Details_ResponseWindow bills 
				WHERE campaigns.Customer_Id between ",vStart_Cnt," and ",vEnd_Cnt,"
				AND campaigns.Event_Execution_Date_ID=",V_Event_Execution_Date_ID,"
				AND campaigns.Event_Id=",V_Event_ID,"
				AND ",@Delivery_Check_Query,"
				AND bills.Customer_Id=campaigns.Customer_Id
				AND bills.Bill_DateTime 
					between IFNULL(campaigns.`Delivery_Datetime`,date_add(campaigns.`Event_Execution_Date_ID`,INTERVAL @CamExecDely DAY ))
					AND date_add(IFNULL(campaigns.`Delivery_Datetime`,CAST(CONCAT(date_add(campaigns.`Event_Execution_Date_ID`,INTERVAL @CamExecDely DAY ),' ','",@default_delivery_time,"') AS DATETIME)),INTERVAL (SELECT Event_Response_Days FROM Event_Master WHERE Event_Master.ID = ",V_Event_ID,")  HOUR )
				");
			ELSE
				SET @sql2= concat("INSERT IGNORE into Event_Attribution_History (
					`Customer_Id` ,
					`Bill_Details_ID` ,
					`Bill_Header_ID` ,
					`Bill_Date` ,
					`Product_Id`,
					`Sale_Net_Val`,
					`Sale_Disc_Val`,
					`Sale_Qty`,
					`Event_Execution_ID` ,
					`Event_ID` ,
					`Event_Execution_Date_ID`,
					`In_Control_Group`,
					`In_Event_Control_Group`
					 )
					SELECT 
					bills.`Customer_Id` ,
					bills.`Bill_Details_ID` ,
					bills.`Bill_Header_ID` ,
					bills.`Bill_Date`,
					bills.`Product_Id`,
					bills.`Sale_Net_Val`,
					bills.`Sale_Disc_Val`,
					bills.`Sale_Qty`,
					campaigns.`Event_Execution_ID` ,
					campaigns.`Event_ID` ,
					campaigns.`Event_Execution_Date_ID`,
					campaigns.`In_Control_Group`,
					campaigns.`In_Event_Control_Group`
				FROM Event_Execution_History_1DAY campaigns, CDM_Bill_Details_ResponseWindow bills 
				WHERE campaigns.Customer_Id between ",vStart_Cnt," and ",vEnd_Cnt,"
				AND campaigns.Event_Execution_Date_ID=",V_Event_Execution_Date_ID,"
				AND campaigns.Event_Id=",V_Event_ID,"
				AND ",@Delivery_Check_Query,"
				AND bills.Customer_Id=campaigns.Customer_Id
				AND bills.Bill_date 
					between date_add(",V_Event_Execution_Date_ID,",INTERVAL @CamExecDely DAY )
					AND date_add(",V_Event_Execution_Date_ID,",INTERVAL (@CamExecDely + 
					(SELECT Event_Response_Days FROM Event_Master WHERE Event_Master.ID = ",V_Event_ID,") ) DAY )");
            END IF;
			
            select @sql2;
            prepare stmt from @sql2;
			execute stmt;
			deallocate prepare stmt;
            SET @vStart_Cnt=vStart_Cnt;
			SET @vEnd_Cnt=vEnd_Cnt;
			SET @V_Current_Execution_Date_Id=V_Current_Execution_Date_Id;
			SET @V_Event_ID=V_Event_ID;
            SET @V_Event_Execution_Date_ID=V_Event_Execution_Date_ID;
            
            SET @Check1='N';
            SET @Num_of_Recos=(select Number_Of_Recommendation from Communication_Template where ID=(SELECT Communication_Template_ID from Event_Master where ID=@V_Event_ID));
            SELECT @Num_of_Recos,@vStart_Cnt,@vEnd_Cnt,@V_Current_Execution_Date_Id,@V_Event_Execution_Date_ID,@V_Event_ID;


		END LOOP LOOP_ALL_EVENTS;
		CLOSE curALL_EVENTS;
        		SET vStart_Cnt = vEnd_Cnt+1;
		IF vStart_Cnt  >= @Rec_Cnt THEN
			LEAVE LOOP_ALL_CUSTOMERS;
		END IF;        
	  END LOOP LOOP_ALL_CUSTOMERS; 

      
		INSERT into ETL_Execution_Details (Procedure_Name, Job_Name, Start_Time, End_Time,`Status`, Load_Execution_ID) 
			values ('S_CLM_Event_Attribution ', V_Current_Execution_Date_Id,now(),null,'Dashboard', Load_Exe_ID);
		SELECT 'S_CLM_Event_Attribution :' as '', concat(V_Current_Execution_Date_Id,'_Dashboard') as '', NOW() as '' ; 

		TRUNCATE Event_Attribution_History_1DAY;
		INSERT INTO Event_Attribution_History_1DAY  
        (
        Event_Execution_Id,
		Responder,
		Target_Bills,
        Target_Revenue,
        Target_Discount,
        In_Control_Group,
        In_Event_Control_Group
        )
		SELECT 
		Event_Attribution_History.Event_Execution_ID AS Event_Execution_Id,
		1 AS Responder,
		count(distinct Bill_Header_Id) AS Target_Bills,	
        SUM(Event_Attribution_History.Sale_Net_Val) as Target_Revenue,
        SUM(Event_Attribution_History.Sale_Disc_Val) as Target_Discount,
		MAX(Event_Attribution_History.In_Control_Group) AS In_Control_Group,
		MAX(Event_Attribution_History.In_Event_Control_Group) AS In_Event_Control_Group
	FROM
		Event_Attribution_History
	WHERE
		Event_Execution_Date_Id = V_Current_Execution_Date_Id
	GROUP BY Event_Attribution_History.Event_Execution_ID ;
    
    
    SET @Override_Revenue_From_BillHeader=0;
    SELECT ifnull(value,0) into @Override_Revenue_From_BillHeader from CLM_Response_Config where name='Override_Revenue_From_BillHeader';
	IF @Override_Revenue_From_BillHeader = 1
	THEN
				UPDATE Event_Attribution_History_1DAY EA,  ( SELECT 
					SUM(Bill_Total_Val) AS Revenue,
					SUM(Bill_Disc) AS Discount,
					Event_Execution_Id
				FROM
					(SELECT DISTINCT
						A.Bill_Header_ID,
							B.Bill_Total_Val,
							B.Bill_Disc,
							A.Event_Execution_Id
					FROM
						Event_Attribution_History A, CDM_Bill_Header B
					WHERE A.Event_Execution_Date_ID=V_Current_Execution_Date_Id
					AND   A.Customer_Id = B.Customer_Id
					AND A.Bill_Header_Id = B.Bill_Header_Id
					GROUP BY A.Event_Execution_ID , A.Bill_Header_ID) TEMPAlias1
				GROUP BY Event_Execution_ID) revenueforevent
				SET EA.Target_Revenue = revenueforevent.Revenue,
					EA.Target_Discount = revenueforevent.discount
				WHERE EA.Event_Execution_Id=revenueforevent.Event_Execution_Id;
			END IF;
			
			DELETE FROM CLM_Event_Dashboard WHERE EE_Date=V_Current_Execution_Date;
			INSERT INTO CLM_Event_Dashboard
				(`Revenue Center`,
				`Segment`,
				`Campaign`,
				`EE_Date`,
				`Event_Execution_Date_ID`,
				`Theme`,
				`Offer`,
				`Channel`,
				`Event_ID`,
				`Control_Base`,
				`Control_Base_Event`,
				`Target_Base`,
				`Target_Delivered`,
				`Target_Delivered_NA`,
				`Control_Responder`,
				`Control_Responder_Event`,
				`Target_Responder`,
				`Target_Revenue`,
                `CTA_Responder`,
				 `CTA_Revenue`,
                 `CTA_Bills`,
				`Target_Discount`,
				`Target_Bills`,
				`Target_Open`,
				`Target_CTA`,
                `Control_Revenue`,
				`Control_Discount`,
				`Control_Bills`,
                `YM`)
				select 
				 `Revenue_Center`,
				 Segment,
				 Campaign,
				 EE_Date,
				 Event_Execution_Date_ID,
				 Theme,
				 Offer,
				 Channel,
				 Event_ID,
				 Control_Base,
				 Control_Base_Event,
				 Target_Base,
				 Target_Delivered,
				 Target_Delivered_NA,
				 Control_Responder,
				 Control_Responder_Event,
				 Target_Responder,
				 Target_Revenue,
                 `CTA_Responder`,
				 `CTA_Revenue`,
                 `CTA_Bills`,
				 Target_Discount,
				 Target_Bills,
				 Target_Open,
				 Target_CTA,
                 Control_Revenue,
				 Control_Discount,
				 Control_Bills,
                 date_format(EE_Date,"%Y%m")
				from CLM_Event_Dashboard_View;
            
            SET SQL_SAFE_UPDATES=0;
            
			UPDATE CLM_Event_Dashboard
            set Total_Customer_Base = (select count(distinct Customer_Id) from CDM_Customer_Master);
            
            Update CLM_Event_Dashboard
            SET Total_Distinct_Customers_Targeted_This_Day =(select count(distinct Customer_Id) from Event_Execution_History_1DAY)
            where EE_Date = V_Current_Execution_Date;
     
     /*
            Update CLM_Event_Dashboard ced, (select a.Event_Id,`c`.`CampaignName` AS `Campaign`,a.Event_Execution_Date_Id, count(distinct Customer_Id) as cnt from Event_Execution_History_1DAY a JOIN `Event_Master` `b` ON (`a`.`Event_ID` = `b`.`ID`)
        JOIN `CLM_Campaign` `c` ON (`b`.`Event_Type_ID` = `c`.`CampaignId`) group by `c`.`CampaignName` ) eeh
            SET ced.Total_Distinct_Customers_Targeted_This_Day_This_Campaign = eeh.cnt
            where ced.EE_Date = eeh.Event_Execution_Date_Id
            and ced.Event_Id=eeh.Event_Id;
            
   */        
   
      /* Author :RP Date: 24/May/2023.  Perf Fix for Response Engine */
        
/* Compute Metrics for this month- Total Coverage and Revenue */  
select last_day(V_Current_Execution_Date_Id - interval 1 month) + interval 1 day into @FirstDayOfThisMonth;
select last_day(V_Current_Execution_Date_Id) into @LastDayOfThisMonth;
SELECT count(DISTINCT Customer_Id) into @ThisMonthCount from Event_Execution_History 
where Event_Execution_Date_Id between date_format(@FirstDayOfThisMonth,'%Y%m%d') and date_format(@LastDayOfThisMonth,'%Y%m%d');
UPDATE CLM_Event_Dashboard SET Total_Distinct_Customers_Targeted_This_Month=@ThisMonthCount  
where YM=extract(year_month from V_Current_Execution_Date_Id);

SELECT SUM(Sale_Net_Val) into @ThisMonthRevenue from CDM_Bill_Details 
		where Bill_Year_Month=extract(year_month from V_Current_Execution_Date_Id);
	UPDATE CLM_Event_Dashboard set Total_Revenue_This_Month=@ThisMonthRevenue 
		where YM=extract(year_month from V_Current_Execution_Date_Id);
        
select V_Current_Execution_Date_Id,V_Current_Execution_Date_Id_End,@ThisMonthCount, @FirstDayOfThisMonth, @LastDayOfThisMonth, 
@ThisMonthRevenue;
   	
	set V_Current_Execution_Date=date_sub(V_Current_Execution_Date,interval 1 day);
	set V_Current_Execution_Date_Id=date_format(V_Current_Execution_Date,'%Y%m%d');

END LOOP LOOP_ALL_DATES;
/*
UPDATE CLM_Event_Dashboard a,(select date_format(eeh.Event_Execution_Date_ID,"%Y%m") YM,et.Name,count(distinct Customer_Id) cnt from Event_Execution_History eeh join Event_Master em on eeh.Event_Id=em.ID 
join Event_Type et on et.ID=em.Arms
where Event_Execution_Date_ID > date_format(date_sub(current_date(),interval 30 day),"%Y%m01")
group by et.Name,date_format(eeh.Event_Execution_Date_ID,"%Y%m")) b
SET a.Total_Distinct_Customers_Targeted_This_Month_This_Theme=b.cnt
where date_format(a.Event_Execution_Date_ID,"%Y%m")=b.YM
and a.Theme=b.Name;

UPDATE CLM_Event_Dashboard ced,(select date_format(a.Event_Execution_Date_ID,"%Y%m") YM,a.Event_Id,`c`.`CampaignName`
AS `Campaign`,a.Event_Execution_Date_Id, count(distinct Customer_Id) as cnt from Event_Execution_History a 
JOIN `Event_Master` `b` ON (`a`.`Event_ID` = `b`.`ID`)
JOIN `CLM_Campaign` `c` ON (`b`.`Event_Type_ID` = `c`.`CampaignId`)
where a.Event_Execution_Date_ID > date_format(date_sub(current_date(),interval 30 day),"%Y%m01")
group by `c`.`CampaignName`,date_format(a.Event_Execution_Date_ID,"%Y%m")) eeh
SET ced.Total_Distinct_Customers_Targeted_This_Month_This_Campaign=eeh.cnt
where date_format(ced.Event_Execution_Date_ID,"%Y%m")=eeh.YM
and ced.Event_Id=eeh.Event_Id;

UPDATE CLM_Event_Dashboard ced,(select date_format(a.Event_Execution_Date_ID,"%Y%m") YM,`b`.`CLMSegmentName` AS `Segment`,a.Event_Execution_Date_Id, count(distinct Customer_Id) as cnt from Event_Execution_History a 
JOIN `CLM_Segment` `b` ON (`a`.`Segment_Id` = `b`.`CLMSegmentId`)
where a.Event_Execution_Date_ID > date_format(date_sub(current_date(),interval 30 day),"%Y%m01")
group by `b`.`CLMSegmentName`,date_format(a.Event_Execution_Date_ID,"%Y%m")) eeh
SET ced.Total_Distinct_Customers_Targeted_This_Month_This_Segment=eeh.cnt
where date_format(ced.Event_Execution_Date_ID,"%Y%m")=eeh.YM
and ced.Segment=eeh.Segment;
*/

DELETE FROM Monthly_Cost_Incr_Bill_Temp;

INSERT INTO Monthly_Cost_Incr_Bill_Temp
SELECT  date_format(EE_DATE,"%b-%Y") AS "Year" ,EE_Date,YM,(ifnull((select SUM(Target_Delivered)*(select Value1 from UI_Configuration_Global where Config_Name = "Cost_per_SMS") from Monthly_Cost_Incr_Bill_Temp_View a where `Channel`="SMS" and a.YM = ced.YM),0) +
ifnull((select SUM(Target_Delivered)*(select Value1 from UI_Configuration_Global where Config_Name = "Cost_per_PN") from Monthly_Cost_Incr_Bill_Temp_View b where `Channel`="PN" and b.YM = ced.YM),0) +
ifnull((select SUM(Target_Delivered)*(select Value1 from UI_Configuration_Global where Config_Name = "Cost_per_EMAIL") from Monthly_Cost_Incr_Bill_Temp_View c where `Channel`="EMAIL" and c.YM = ced.YM),0) +
ifnull((select SUM(Target_Delivered)*(select Value1 from UI_Configuration_Global where Config_Name = "Cost_per_Whatsapp") from Monthly_Cost_Incr_Bill_Temp_View d where `Channel`="WhatsApp" and d.YM = ced.YM),0)+
ifnull((select CASE WHEN ifnull(SUM(Target_Delivered),0) <= 0 THEN 0 ELSE (select Value1 from UI_Configuration_Global where Config_Name = "Monthly_Creative_Cost") END from Monthly_Cost_Incr_Bill_Temp_View e where e.YM =ced.YM),0) +
ifnull((select CASE WHEN ifnull(SUM(Target_Delivered),0) <= 0 THEN 0 ELSE (select Value1 from UI_Configuration_Global where Config_Name = "Monthly_Platform_Cost") END from Monthly_Cost_Incr_Bill_Temp_View f where f.YM =ced.YM),0) +
ifnull((select CASE WHEN ifnull(SUM(Target_Delivered),0) <= 0 THEN 0 ELSE (select Value1 from UI_Configuration_Global where Config_Name = "Monthly_Other_Cost") END from Monthly_Cost_Incr_Bill_Temp_View g where g.YM =ced.YM),0)),
round(SUM(Incremental_Revenue),0) ,
ifnull(CASE WHEN SUM(Target_Bills)-SUM(Control_Bills)<=0 THEN 0 ELSE (SUM(Target_Bills)-SUM(Control_Bills)) END,0),
(ifnull((select SUM(Target_Delivered)*(select Value1 from UI_Configuration_Global where Config_Name = "Cost_per_SMS") from Monthly_Cost_Incr_Bill_Temp_View a where `Channel`="SMS" and a.YM = ced.YM),0) +
ifnull((select SUM(Target_Delivered)*(select Value1 from UI_Configuration_Global where Config_Name = "Cost_per_PN") from Monthly_Cost_Incr_Bill_Temp_View b where `Channel`="PN" and b.YM = ced.YM),0) +
ifnull((select SUM(Target_Delivered)*(select Value1 from UI_Configuration_Global where Config_Name = "Cost_per_EMAIL") from Monthly_Cost_Incr_Bill_Temp_View c where `Channel`="EMAIL" and c.YM = ced.YM),0) +
ifnull((select SUM(Target_Delivered)*(select Value1 from UI_Configuration_Global where Config_Name = "Cost_per_Whatsapp") from Monthly_Cost_Incr_Bill_Temp_View d where `Channel`="WhatsApp" and d.YM = ced.YM),0)+
ifnull((select CASE WHEN ifnull(SUM(Target_Delivered),0) <= 0 THEN 0 ELSE (select Value1 from UI_Configuration_Global where Config_Name = "Monthly_Creative_Cost") END from Monthly_Cost_Incr_Bill_Temp_View e where e.YM =ced.YM),0) +
ifnull((select CASE WHEN ifnull(SUM(Target_Delivered),0) <= 0 THEN 0 ELSE (select Value1 from UI_Configuration_Global where Config_Name = "Monthly_Platform_Cost") END from Monthly_Cost_Incr_Bill_Temp_View f where f.YM =ced.YM),0) +
ifnull((select CASE WHEN ifnull(SUM(Target_Delivered),0) <= 0 THEN 0 ELSE (select Value1 from UI_Configuration_Global where Config_Name = "Monthly_Other_Cost") END from Monthly_Cost_Incr_Bill_Temp_View g where g.YM =ced.YM),0))/( round(SUM(Incremental_Revenue),0) ) ,
(ifnull((select SUM(Target_Delivered)*(select Value1 from UI_Configuration_Global where Config_Name = "Cost_per_SMS") from Monthly_Cost_Incr_Bill_Temp_View a where `Channel`="SMS" and a.YM = ced.YM),0) +
ifnull((select SUM(Target_Delivered)*(select Value1 from UI_Configuration_Global where Config_Name = "Cost_per_PN") from Monthly_Cost_Incr_Bill_Temp_View b where `Channel`="PN" and b.YM = ced.YM),0) +
ifnull((select SUM(Target_Delivered)*(select Value1 from UI_Configuration_Global where Config_Name = "Cost_per_EMAIL") from Monthly_Cost_Incr_Bill_Temp_View c where `Channel`="EMAIL" and c.YM = ced.YM),0) +
ifnull((select SUM(Target_Delivered)*(select Value1 from UI_Configuration_Global where Config_Name = "Cost_per_Whatsapp") from Monthly_Cost_Incr_Bill_Temp_View d where `Channel`="WhatsApp" and d.YM = ced.YM),0)+
ifnull((select CASE WHEN ifnull(SUM(Target_Delivered),0) <= 0 THEN 0 ELSE (select Value1 from UI_Configuration_Global where Config_Name = "Monthly_Creative_Cost") END from Monthly_Cost_Incr_Bill_Temp_View e where e.YM =ced.YM),0) +
ifnull((select CASE WHEN ifnull(SUM(Target_Delivered),0) <= 0 THEN 0 ELSE (select Value1 from UI_Configuration_Global where Config_Name = "Monthly_Platform_Cost") END from Monthly_Cost_Incr_Bill_Temp_View f where f.YM =ced.YM),0) +
ifnull((select CASE WHEN ifnull(SUM(Target_Delivered),0) <= 0 THEN 0 ELSE (select Value1 from UI_Configuration_Global where Config_Name = "Monthly_Other_Cost") END from Monthly_Cost_Incr_Bill_Temp_View g where g.YM =ced.YM),0))/(ifnull(CASE WHEN SUM(Target_Bills)-SUM(Control_Bills)<=0 THEN 0 ELSE (SUM(Target_Bills)-SUM(Control_Bills)) END,0)) 
from Monthly_Cost_Incr_Bill_Temp_View ced
group by 1;

/*
UPDATE CLM_Event_Dashboard  a,(select date_format(Event_Execution_Date_Id,"%Y%m") as YM,count(DISTINCT Customer_Id) as cnt from Event_Execution_History where Event_Execution_Date_ID > date_format(date_sub(current_date(),interval 30 day),"%Y%m01")
group by date_format(Event_Execution_Date_Id,"%Y%m"))b
SET Total_Distinct_Customers_Targeted_This_Month=b.cnt
where a.YM=b.YM;

UPDATE CLM_Event_Dashboard  a,(select Bill_Date,SUM(Sale_Net_Val) as 'Rev' from CDM_Bill_Details where Bill_Date > date_sub(current_date(),interval 180 day) group by Bill_Date) b
set a.Total_Revenue_This_Day=b.Rev
where a.EE_Date=b.Bill_Date;

UPDATE CLM_Event_Dashboard  a,(select Bill_Year_Month,SUM(Sale_Net_Val) as 'Rev' from CDM_Bill_Details where Bill_Date > date_format(date_sub(current_date(),interval 180 day),"%Y-%m-01") group by Bill_Year_Month) b
set a.Total_Revenue_This_Month=b.Rev
where a.YM=b.Bill_Year_Month;
*/



/* If start date and end date are in different months, compute metrics for both months 

/* Compute Last Month Metrics - Total Coverage and Revenue 
select last_day(V_Current_Execution_Date_Id - interval 1 month) into @FirstDayOfLastMonth;
select last_day(V_Current_Execution_Date_Id) into @LastDayOfLastMonth;
SELECT count(DISTINCT Customer_Id) into @LastMonthCount from Event_Execution_History 
where Event_Execution_Date_Id between date_format(@FirstDayOfLastMonth,'%Y%m%d') and date_format(@LastDayOfLastMonth,'%Y%m%d');
UPDATE CLM_Event_Dashboard SET Total_Distinct_Customers_Targeted_This_Month=@LastMonthCount  
where YM=extract(year_month from V_Current_Execution_Date_Id);

SELECT SUM(Sale_Net_Val) into @LastMonthRevenue from CDM_Bill_Details 
		where Bill_Year_Month=extract(year_month from V_Current_Execution_Date_Id);
	UPDATE CLM_Event_Dashboard set Total_Revenue_This_Month=@LastMonthRevenue 
		where YM=extract(year_month from V_Current_Execution_Date_Id);
        
IF extract(year_month from V_Current_Execution_Date_Id) != extract(year_month from V_Current_Execution_Date_Id_End)
THEN
	SELECT SUM(Sale_Net_Val) into @LastMonthRevenue from CDM_Bill_Details 
		where Bill_Year_Month=extract(year_month from V_Current_Execution_Date_Id);
	UPDATE CLM_Event_Dashboard set Total_Revenue_This_Month=@LastMonthRevenue 
		where YM=extract(year_month from V_Current_Execution_Date_Id);
    
	SELECT last_day(V_Current_Execution_Date_Id - interval 1 month) + interval 1 day into @FirstDayOfStartMonth;
	SELECT last_day(V_Current_Execution_Date_Id) into @LastdayofStartMonth;
	SELECT count(DISTINCT Customer_Id) into @count from Event_Execution_History 
		where Event_Execution_Date_Id between @FirstDayOfStartMonth and @LastdayofStartMonth;
	UPDATE CLM_Event_Dashboard SET Total_Distinct_Customers_Targeted_This_Month=@count  
		where YM=extract(year_month from V_Current_Execution_Date_Id);
END IF;
select V_Current_Execution_Date_Id,V_Current_Execution_Date_Id_End,@ThisMonthCount, @FirstDayOfCurrentMonth, @ThisMonthRevenue, @FirstDayOfCurrentMonth,@FirstDayOfStartMonth,@LastdayofStartMonth;
/* End Of Fix : Author :RP Date: 24/May/2023.  Perf Fix for Response Engine */

set sql_safe_updates=0;
UPDATE CLM_Event_Dashboard a,
(
select YM,Event_ID,
round((
CASE 
WHEN SUM(Control_Base) < 100 or SUM(Target_Delivered) = 0 or sum(Target_Responder)=0 then 0 
WHEN (((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder)/SUM(Control_Base))))*100 < 0 then 0 
WHEN SUM(Control_Base)>0 and SUM(Control_Responder)=0 then SUM(Target_Revenue)
ELSE ifnull((((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder)/SUM(Control_Base))))*(SUM(Target_Revenue)/SUM(Target_Responder))*(SUM(Target_Delivered)),0) 
END),1) as Incremental_Revenue 
from CLM_Event_Dashboard
group by Event_ID,YM
) b
SET a.MTD_Incremental_Revenue_CG100 = b.Incremental_Revenue
where a.Event_ID=b.Event_ID
and a.YM=b.YM;

UPDATE CLM_Event_Dashboard a,
(
select YM,Event_ID,
round((
CASE 
WHEN SUM(Control_Base) < 1 or SUM(Target_Delivered) = 0 or sum(Target_Responder)=0 then 0 
WHEN (((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder)/SUM(Control_Base))))*100 < 0 then 0 
WHEN SUM(Control_Base)>0 and SUM(Control_Responder)=0 then SUM(Target_Revenue)
ELSE ifnull((((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder)/SUM(Control_Base))))*(SUM(Target_Revenue)/SUM(Target_Responder))*(SUM(Target_Delivered)),0) 
END),1) as Incremental_Revenue 
from CLM_Event_Dashboard
group by Event_ID,YM
) b
SET a.MTD_Incremental_Revenue = b.Incremental_Revenue
where a.Event_ID=b.Event_ID
and a.YM=b.YM;




UPDATE CLM_Event_Dashboard a,
(
select YM,Segment,Event_ID,
round((
CASE 
WHEN SUM(Control_Base) < 1 or SUM(Target_Delivered) = 0 or sum(Target_Responder)=0 then 0 
WHEN (((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder)/SUM(Control_Base))))*100 < 0 then 0 
WHEN SUM(Control_Base)>0 and SUM(Control_Responder)=0 then SUM(Target_Revenue)
ELSE ifnull((((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder)/SUM(Control_Base))))*(SUM(Target_Revenue)/SUM(Target_Responder))*(SUM(Target_Delivered)),0) 
END),1) as Incremental_Revenue 
from CLM_Event_Dashboard
group by Segment,Event_ID,YM
) b
SET a.MTD_Incremental_Revenue_By_Segment = b.Incremental_Revenue
where  a.Segment=b.Segment
and a.Event_ID=b.Event_ID
and a.YM=b.YM;



UPDATE CLM_Event_Dashboard a,
(
select YM,`Revenue Center`,Event_ID,
round((
CASE 
WHEN SUM(Control_Base) < 1 or SUM(Target_Delivered) = 0 or sum(Target_Responder)=0 then 0 
WHEN (((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder)/SUM(Control_Base))))*100 < 0 then 0 
WHEN SUM(Control_Base)>0 and SUM(Control_Responder)=0 then SUM(Target_Revenue)
ELSE ifnull((((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder)/SUM(Control_Base))))*(SUM(Target_Revenue)/SUM(Target_Responder))*(SUM(Target_Delivered)),0) 
END),1) as Incremental_Revenue 
from CLM_Event_Dashboard
group by `Revenue Center`,Event_ID,YM
) b
SET a.MTD_Incremental_Revenue_By_Revenue_Center = b.Incremental_Revenue
where  a.`Revenue Center`=b.`Revenue Center`
and a.Event_ID=b.Event_ID
and a.YM=b.YM;


UPDATE CLM_Event_Dashboard a,
(
select Event_Execution_Date_ID,YM,Segment,`Revenue Center`,Event_ID,
round((
CASE 
WHEN SUM(Control_Base) < 1 or SUM(Target_Delivered) = 0 or sum(Target_Responder)=0 then 0 
WHEN (((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder)/SUM(Control_Base))))*100 < 0 then 0 
WHEN SUM(Control_Base)>0 and SUM(Control_Responder)=0 then SUM(Target_Revenue)
ELSE ifnull((((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder)/SUM(Control_Base))))*(SUM(Target_Revenue)/SUM(Target_Responder))*(SUM(Target_Delivered)),0) 
END),1) as Incremental_Revenue 
from CLM_Event_Dashboard
group by Event_Execution_Date_ID,Segment,`Revenue Center`,Event_ID,YM
) b
SET a.Incremental_Revenue = b.Incremental_Revenue
where  a.Event_Execution_Date_ID=b.Event_Execution_Date_ID
and a.Segment=b.Segment
and a.`Revenue Center`=b.`Revenue Center`
and a.Event_ID=b.Event_ID
and a.YM=b.YM;





set sql_safe_updates=0;


UPDATE CLM_Event_Dashboard a,
(
select YM,Event_ID,
round((
CASE 
WHEN SUM(Control_Base_Event) < 1 or SUM(Target_Delivered) = 0 or sum(Target_Responder)=0 then 0 
WHEN (((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder_Event)/SUM(Control_Base_Event))))*100 < 0 then 0 
WHEN SUM(Control_Base_Event)>0 and SUM(Control_Responder_Event)=0 then SUM(Target_Revenue)
ELSE ifnull((((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder_Event)/SUM(Control_Base_Event))))*(SUM(Target_Revenue)/SUM(Target_Responder))*(SUM(Target_Delivered)),0) 
END),1) as Incremental_Revenue 
from CLM_Event_Dashboard
group by Event_ID,YM
) b
SET a.MTD_Incremental_Revenue_ST = b.Incremental_Revenue
where a.Event_ID=b.Event_ID
and a.YM=b.YM;



UPDATE CLM_Event_Dashboard a,
(
select YM,Segment,Event_ID,
round((
CASE 
WHEN SUM(Control_Base_Event) < 1 or SUM(Target_Delivered) = 0 or sum(Target_Responder)=0 then 0 
WHEN (((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder_Event)/SUM(Control_Base_Event))))*100 < 0 then 0 
WHEN SUM(Control_Base_Event)>0 and SUM(Control_Responder_Event)=0 then SUM(Target_Revenue)
ELSE ifnull((((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder_Event)/SUM(Control_Base_Event))))*(SUM(Target_Revenue)/SUM(Target_Responder))*(SUM(Target_Delivered)),0) 
END),1) as Incremental_Revenue 
from CLM_Event_Dashboard
group by Segment,Event_ID,YM
) b
SET a.MTD_Incremental_Revenue_By_Segment_ST = b.Incremental_Revenue
where  a.Segment=b.Segment
and a.Event_ID=b.Event_ID
and a.YM=b.YM;



UPDATE CLM_Event_Dashboard a,
(
select YM,`Revenue Center`,Event_ID,
round((
CASE 
WHEN SUM(Control_Base_Event) < 1 or SUM(Target_Delivered) = 0 or sum(Target_Responder)=0 then 0 
WHEN (((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder_Event)/SUM(Control_Base_Event))))*100 < 0 then 0 
WHEN SUM(Control_Base_Event)>0 and SUM(Control_Responder_Event)=0 then SUM(Target_Revenue)
ELSE ifnull((((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder_Event)/SUM(Control_Base_Event))))*(SUM(Target_Revenue)/SUM(Target_Responder))*(SUM(Target_Delivered)),0) 
END),1) as Incremental_Revenue 
from CLM_Event_Dashboard
group by `Revenue Center`,Event_ID,YM
) b
SET a.MTD_Incremental_Revenue_By_Revenue_Center_ST = b.Incremental_Revenue
where  a.`Revenue Center`=b.`Revenue Center`
and a.Event_ID=b.Event_ID
and a.YM=b.YM;


UPDATE CLM_Event_Dashboard a,
(
select Event_Execution_Date_ID,YM,Segment,`Revenue Center`,Event_ID,
round((
CASE 
WHEN SUM(Control_Base_Event) < 1 or SUM(Target_Delivered) = 0 or sum(Target_Responder)=0 then 0 
WHEN (((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder_Event)/SUM(Control_Base_Event))))*100 < 0 then 0 
WHEN SUM(Control_Base_Event)>0 and SUM(Control_Responder_Event)=0 then SUM(Target_Revenue)
ELSE ifnull((((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder_Event)/SUM(Control_Base_Event))))*(SUM(Target_Revenue)/SUM(Target_Responder))*(SUM(Target_Delivered)),0) 
END),1) as Incremental_Revenue 
from CLM_Event_Dashboard
group by Event_Execution_Date_ID,Segment,`Revenue Center`,Event_ID,YM
) b
SET a.Incremental_Revenue_ST = b.Incremental_Revenue
where  a.Event_Execution_Date_ID=b.Event_Execution_Date_ID
and a.Segment=b.Segment
and a.`Revenue Center`=b.`Revenue Center`
and a.Event_ID=b.Event_ID
and a.YM=b.YM;



UPDATE CLM_Event_Dashboard a,
(
select EE_Date,Event_ID,
round((
CASE 
WHEN SUM(Control_Base) < 1 or SUM(Target_Delivered) = 0 or sum(Target_Responder)=0 then 0 
WHEN (((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder)/SUM(Control_Base))))*100 < 0 then 0 
WHEN SUM(Control_Base)>0 and SUM(Control_Responder)=0 then SUM(Target_Revenue)
ELSE ifnull((((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder)/SUM(Control_Base))))*(SUM(Target_Revenue)/SUM(Target_Responder))*(SUM(Target_Delivered)),0) 
END),1) as Incremental_Revenue 
from CLM_Event_Dashboard
group by Event_ID,EE_Date
) b
SET a.Incremental_Revenue_By_Day = b.Incremental_Revenue
where a.Event_ID=b.Event_ID
and a.EE_Date=b.EE_Date;

UPDATE CLM_Event_Dashboard a,
(
select EE_Date,Segment,Event_ID,
round((
CASE 
WHEN SUM(Control_Base) < 1 or SUM(Target_Delivered) = 0 or sum(Target_Responder)=0 then 0 
WHEN (((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder)/SUM(Control_Base))))*100 < 0 then 0 
WHEN SUM(Control_Base)>0 and SUM(Control_Responder)=0 then SUM(Target_Revenue)
ELSE ifnull((((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder)/SUM(Control_Base))))*(SUM(Target_Revenue)/SUM(Target_Responder))*(SUM(Target_Delivered)),0) 
END),1) as Incremental_Revenue 
from CLM_Event_Dashboard
group by Segment,Event_ID,EE_Date
) b
SET a.Incremental_Revenue_By_Segment_By_Day = b.Incremental_Revenue
where  a.Segment=b.Segment
and a.Event_ID=b.Event_ID
and a.EE_Date=b.EE_Date;

UPDATE CLM_Event_Dashboard a,
(
select EE_Date,`Revenue Center`,Event_ID,
round((
CASE 
WHEN SUM(Control_Base) < 1 or SUM(Target_Delivered) = 0 or sum(Target_Responder)=0 then 0 
WHEN (((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder)/SUM(Control_Base))))*100 < 0 then 0 
WHEN SUM(Control_Base)>0 and SUM(Control_Responder)=0 then SUM(Target_Revenue)
ELSE ifnull((((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder)/SUM(Control_Base))))*(SUM(Target_Revenue)/SUM(Target_Responder))*(SUM(Target_Delivered)),0) 
END),1) as Incremental_Revenue 
from CLM_Event_Dashboard
group by `Revenue Center`,Event_ID,EE_Date
) b
SET a.Incremental_Revenue_By_Revenue_Center_By_Day = b.Incremental_Revenue
where  a.`Revenue Center`=b.`Revenue Center`
and a.Event_ID=b.Event_ID
and a.EE_Date=b.EE_Date;


UPDATE CLM_Event_Dashboard a,
(
select EE_Date,Event_ID,
round((
CASE 
WHEN SUM(Control_Base_Event) < 1 or SUM(Target_Delivered) = 0 or sum(Target_Responder)=0 then 0 
WHEN (((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder_Event)/SUM(Control_Base_Event))))*100 < 0 then 0 
WHEN SUM(Control_Base_Event)>0 and SUM(Control_Responder_Event)=0 then SUM(Target_Revenue)
ELSE ifnull((((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder_Event)/SUM(Control_Base_Event))))*(SUM(Target_Revenue)/SUM(Target_Responder))*(SUM(Target_Delivered)),0) 
END),1) as Incremental_Revenue 
from CLM_Event_Dashboard
group by Event_ID,EE_Date
) b
SET a.Incremental_Revenue_ST_By_Day = b.Incremental_Revenue
where a.Event_ID=b.Event_ID
and a.EE_Date=b.EE_Date;



UPDATE CLM_Event_Dashboard a,
(
select EE_Date,Segment,Event_ID,
round((
CASE 
WHEN SUM(Control_Base_Event) < 1 or SUM(Target_Delivered) = 0 or sum(Target_Responder)=0 then 0 
WHEN (((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder_Event)/SUM(Control_Base_Event))))*100 < 0 then 0 
WHEN SUM(Control_Base_Event)>0 and SUM(Control_Responder_Event)=0 then SUM(Target_Revenue)
ELSE ifnull((((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder_Event)/SUM(Control_Base_Event))))*(SUM(Target_Revenue)/SUM(Target_Responder))*(SUM(Target_Delivered)),0) 
END),1) as Incremental_Revenue 
from CLM_Event_Dashboard
group by Segment,Event_ID,EE_Date
) b
SET a.Incremental_Revenue_By_Segment_ST_By_Day = b.Incremental_Revenue
where  a.Segment=b.Segment
and a.Event_ID=b.Event_ID
and a.EE_Date=b.EE_Date;



UPDATE CLM_Event_Dashboard a,
(
select EE_Date,`Revenue Center`,Event_ID,
round((
CASE 
WHEN SUM(Control_Base_Event) < 1 or SUM(Target_Delivered) = 0 or sum(Target_Responder)=0 then 0 
WHEN (((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder_Event)/SUM(Control_Base_Event))))*100 < 0 then 0 
WHEN SUM(Control_Base_Event)>0 and SUM(Control_Responder_Event)=0 then SUM(Target_Revenue)
ELSE ifnull((((SUM(Target_Responder)/SUM(Target_Delivered))-(SUM(Control_Responder_Event)/SUM(Control_Base_Event))))*(SUM(Target_Revenue)/SUM(Target_Responder))*(SUM(Target_Delivered)),0) 
END),1) as Incremental_Revenue 
from CLM_Event_Dashboard
group by `Revenue Center`,Event_ID,EE_Date
) b
SET a.Incremental_Revenue_By_Revenue_Center_ST_By_Day = b.Incremental_Revenue
where  a.`Revenue Center`=b.`Revenue Center`
and a.Event_ID=b.Event_ID
and a.EE_Date=b.EE_Date;



update ETL_Execution_Details
        set Status ='Succeeded',
        End_Time = now()
        where Procedure_Name='S_CLM_Event_Attribution' and 
        Load_Execution_ID = Load_Exe_ID
        and Execution_ID = Exe_ID;
select 'S_CLM_Event_Attribution : COMPLETED ' as '',  NOW() as '';

UPDATE CLM_Response_Config
SET `Value` = Current_Date()
where `Name` = 'Last_Response_Execution_Date';

UPDATE CLM_Response_Config
SET `Value` = (select date(MIN(Inserted_On)) from Hold_Out)
where `Name` = 'Control_Group_Refresh_Date';

If datediff(Current_Date(),(select `Value` from CLM_Response_Config where `Name`='Control_Group_Refresh_Date'))>(select `Value` from CLM_Response_Config where `Name`='Control_Group_Refresh_Interval')
THEN
	drop table if exists Hold_Out_Bkp_Before_Refresh;
    create table if not exists Hold_Out_Bkp_Before_Refresh as select * from Hold_Out;
    truncate Hold_Out;
    update CDM_Customer_Master set Is_New_Cust_Flag=1;
    UPDATE CLM_Response_Config
	SET `Value` = Current_Date()
	where `Name` = 'Control_Group_Refresh_Date';
END IF;

/*CALL `S_dashboard_explore_variable_metrics`();*/


IF @Check1 = 'Y'
THEN
	CALL S_CLM_Hard_Response();
END IF;

UPDATE Dashboard_Metrics_Log
SET `Status` = 'Ended' WHERE Screen_Name = 'PERFORMANCE - DASHBOARD';

end$$
DELIMITER ;